package com.coob.sjts.common;

import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.CorsRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * @Author: Gao
 * @Date: 2024-01-17-16:10
 * @Description:
 */
@Configuration
public class WebMvcConfig implements WebMvcConfigurer {

   /* @Value("${file.url}")
    private String path;*/


    public void addCorsMappings(CorsRegistry registry) {
        registry.addMapping("/**") // 允许所有路径的跨域请求
                .allowedOriginPatterns("*")// 允许所有来源
                .allowedMethods("GET", "HEAD", "POST", "PUT", "DELETE", "OPTIONS")
//                .allowedHeaders("*") // 允许所有请求头
                .allowCredentials(true)// 允许携带认证信息（cookies）
                .maxAge(3600);// 预检请求的缓存时间，单位为秒
    }
}
