package com.coob.sjts.common.stUtil;

import com.coob.sjts.common.utils.DateUtil;
import org.apache.commons.lang3.StringUtils;

/**
 * @author : wangqingli
 * @Description: 数据推送 - 序号 -工具类
 * @date 2024-06-05-13:51
 * @modify by：wangqingli
 */
public class SjtsCreateXhUtils {

    private static final String XZQHDM = "370783";

    /**
     * 序号字段更正生成规则   区县行政区划代码6位+8位日期+8位自然数（确保唯一）
     *
     * @param xh
     * @return
     */
    public static String createXh(String xh) {
        String id8 = StringUtils.leftPad(xh, 8, "0");
        String yyyyMMdd = DateUtil.getCurDateStr("yyyyMMdd");
        // 规则生成序号
        StringBuffer buffer = new StringBuffer();
        // 邹平
        buffer.append(XZQHDM)
                // 8位日期
                .append(yyyyMMdd)
                //8位自然数（确保唯一）
                .append(id8);//
        return buffer.toString();
    }

    /**
     * 【用于判断数据是新增还是更新】
     * 区县行政区划代码6位+32位唯一编码（不足前置0补足）
     *
     * @param ysxkzbm
     * @return
     */
    public static String createYsxkzbm(String ysxkzbm) {
        String id32 = StringUtils.leftPad(ysxkzbm, 32, "0");
        // 规则生成序号
        StringBuffer buffer = new StringBuffer();
        // 邹平
        buffer.append(XZQHDM)
                //32位唯一编码不足前置0补足）
                .append(id32);
        return buffer.toString();
    }

}
