package com.coob.sjts.common.web;

import lombok.Data;

import java.io.Serializable;


@Data
public class ResultTable implements Serializable {

    /**
     * 状态码
     */
    private Integer code;

    /**
     * 提示消息
     */
    private String msg;

    /**
     * 消息总量
     */
    private Long count;

    /**
     * 数据对象
     */
    private Object data;

    public static ResultTable resultTable(int code, String msg, Long count, Object data) {
        ResultTable resultTable = new ResultTable();
        resultTable.setCode(code);
        resultTable.setMsg(msg);
        resultTable.setCount(count);
        resultTable.setData(data);
        return resultTable;
    }

    /**
     * 构建实体
     */
    public static ResultTable pageTable(long count, Object data) {
        ResultTable resultTable = new ResultTable();
        resultTable.setData(data);
        resultTable.setCode(0);
        resultTable.setCount(count);
        return resultTable;
    }

    /**
     * 构建实体
     */
    public static ResultTable dataTable(Object data) {
        ResultTable resultTable = new ResultTable();
        resultTable.setData(data);
        resultTable.setCode(0);
        return resultTable;
    }
}
