package com.coob.sjts.modules.kfxy.service;


import com.coob.sjts.modules.kfxy.domain.KfsXwjl;
import com.coob.sjts.modules.kfxy.mapper.KfsXwjlMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 行为记录机构表(KfsXwjl)表服务实现类
 *
 * @author Awei
 * @since 2023-11-15 09:19:32
 */
@Service
public class KfsXwjlService {


    @Resource
    private KfsXwjlMapper kfsXwjlMapper;


    /**
     * 根据qyid查询行为记录
     * @param qyid
     * @return
     */
    public List<KfsXwjl> selectByQyid(Integer qyid){
        return this.kfsXwjlMapper.selectByQyid(qyid);
    }

    /**
     * 查询所有开发商行为记录
     * @return
     */
    public List<KfsXwjl> selectAllList(){
        return this.kfsXwjlMapper.selectAllList();
    }


    /**
     * 查询所有id大于之前id的数据
     * @param oldId
     * @return
     */
    public List<KfsXwjl> selectByOldId(Integer oldId){
        return this.kfsXwjlMapper.selectByOldId(oldId);
    }



}
