package com.coob.sjts.modules.mis.bo;

import com.coob.sjts.common.utils.DateUtil;
import com.coob.sjts.modules.mis.domain.sjts.SjtsStFwwqba;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

@Data
public class SjtsFwwqbaBo implements Serializable {
    private static final long serialVersionUID = -1L;

    private Integer id;
    private String qyzch;
    private String qymc;
    private String xmbh;
    private String xmmc;
    private String lzmc;
    private String dymc;
    private Integer zcs;
    private Integer dscs;
    private Integer dxcs;
    private String fwbh;
    private String bdcdyh;
    private String fh;
    private String fwzl;
    private Integer szc;
    private Integer kc;
    private BigDecimal cg;
    private String hx;
    private String yt;
    private String jg;
    private String fwlx;
    private BigDecimal yjzmj;
    private BigDecimal jzmj;
    private BigDecimal ytnmj;
    private BigDecimal tnmj;
    private BigDecimal ygtmj;
    private BigDecimal gtmj;
    private String ywbh;
    private String htbh;
    private Integer htlb;
    private Integer htzt;
    private BigDecimal htmj;
    private BigDecimal fwjg;
    private Integer dkfs;
    private String srf;
    private String sfz;
    private String gyr1;
    private String sfz1;
    private String gyr2;
    private String sfz2;
    private String gyr3;
    private String sfz3;
    private String ywsj;
    private String basj;


    public List<SjtsStFwwqba> createWqba() {
        List<SjtsStFwwqba> list = new ArrayList<>();

        SjtsStFwwqba baBase = this.createBase();

        //序号：规则：区县行政区划代码6位+6位日期 + 1位备案状态（1未备案、2备案） + 8位顺序号（id） + 1位人员顺序号（0开发商）
        String _xh = "370783" + DateUtil.getCurDateStr("YYYYMMdd");              //序号   区县行政区划代码6位+8位日期+8位自然数（确保唯一）
        String _id = ""+ this.id;
        for( int i=_id.length(); i<8; i++ ) {
            _id = "0" + _id;
        }
        _xh = _xh + baBase.getBazt() + _id;
        baBase.setXh(_xh);

        //开发企业
        SjtsStFwwqba wq = this.createKfs(baBase);
        list.add(wq);

        if( baBase.getTszt() == 0 ) {
            return list;
        }

        //受让方判断
        if( this.srf == null || this.srf.length() == 0 || this.sfz == null || this.sfz.length() == 0 ) {
            wq.setTszt(0);
            return list;
        }

        //受让方
        SjtsStFwwqba wq1 = this.createSrf(baBase, this.srf, this.sfz, 1);
        list.add(wq1);

        if( this.gyr1 != null && this.gyr1.length() > 0 && this.sfz1 != null && this.sfz1.length() > 0 ) {
            SjtsStFwwqba wq2 = this.createSrf(baBase, this.gyr1, this.sfz1, 2);
            list.add(wq2);
        }

        if( this.gyr2 != null && this.gyr2.length() > 0 && this.sfz2 != null && this.sfz2.length() > 0 ) {
            SjtsStFwwqba wq3 = this.createSrf(baBase, this.gyr2, this.sfz2, 3);
            list.add(wq3);
        }

        if( this.gyr3 != null && this.gyr3.length() > 0 && this.sfz3 != null && this.sfz3.length() > 0 ) {
            SjtsStFwwqba wq4 = this.createSrf(baBase, this.gyr3, this.sfz3, 4);
            list.add(wq4);
        }

        if( list.size() == 2 ) {
            for( SjtsStFwwqba b : list ) {
                b.setGyfs("单独占有");
                b.setGyfsbm("01");
            }
        }

        return list;
    }


    private SjtsStFwwqba createBase(){
        String curT = DateUtil.getCurDateStr("yyyyMMddHHmmss");
        String qxdm = "370783";
        String qxmc = "寿光市";
        int tszt = 1;

        SjtsStFwwqba ba = new SjtsStFwwqba();
        ba.setXmbs(this.xmbh);          //项目标识 = xmbh
        ba.setZcs(this.zcs);            //总层数
        ba.setCg(this.cg);              //层高
        ba.setDscs(this.dscs);          //地上层数
        ba.setDxcs(this.dxcs);          //地下层数
        ba.setJgysbarq(null);           //竣工验收备案日期   无
        ba.setPgjg(null);               //评估价格          无
        ba.setSfyd("01");               //税费约定          无
        ba.setHtzyjjfs("03");           //合同争议解决方式  htlsb_xx.nr27fs:1=04  2=03  //01协商和解、02调解、03仲裁、04申诉、05其他
        ba.setFkfs("04");               //付款方式 04     01银行转账、02三方平台支付（微信/支付宝/信用卡等）、03现金、04其他
        ba.setQlxz("07");               //权利性质 07
        ba.setSjscsj(curT);             //数据生成时间  YYYYMMDDHHMMSS
        ba.setSjgxsj(curT);             //数据更新时间  YYYYMMDDHHMMSS

        ba.setYwbh(this.ywbh);          //业务编号  = htbh
        if( this.ywbh == null || this.ywbh.length() == 0 ) {
            tszt = 0;
        }

        if( this.htlb == 1 ) {
            //预售
            if( this.htzt < 4 ) {
                //未备案
                ba.setLlywlb("商品房预售合同网签");
                ba.setLlywlbbm("005");
                ba.setSjywlb("商品房预售合同网签");
            } else {
                //备案
                ba.setLlywlb("商品房预售合同备案");
                ba.setLlywlbbm("020");
                ba.setSjywlb("商品房预售合同备案");
            }
        } else {
            //现售
            if( this.htzt < 4 ) {
                //未备案
                ba.setLlywlb("商品房现售合同网签");
                ba.setLlywlbbm("041");
                ba.setSjywlb("商品房现售合同网签");
            } else {
                //备案
                ba.setLlywlb("商品现房转让备案");
                ba.setLlywlbbm("056");
                ba.setSjywlb("商品房现售合同备案");
            }
        }

        ba.setYywbh("无");           //上件业务编号 无
        //ba.setJyzt;            //交易状态  01 交易已完成 02 交易将完成
        if( this.htzt < 4 ) {
            ba.setJyzt("02");
        } else {
            ba.setJyzt("01");
        }

        if( this.htlb == 1 ) {
            ba.setJyywzmzsmc("商品期房转让合同");      //交易业务证明证书名称 013 商品期房转让合同 016 商品现房转让合同
            ba.setJyywzmzsmcbm("013");              //交易业务证明证书名称编码
            ba.setFwzt("01");                       //房屋状态
        } else {
            ba.setJyywzmzsmc("商品现房转让合同");      //交易业务证明证书名称 013 商品期房转让合同 016 商品现房转让合同
            ba.setJyywzmzsmcbm("016");              //交易业务证明证书名称编码
            ba.setFwzt("02");               //房屋状态
        }
        ba.setJyywzmzsh(this.htbh);         //交易业务证明证书号
        ba.setDjywzmzsmc(null);              //登记业务证明证书名称：无
        ba.setDjywzmzsmcbm("999");          //登记业务证明证书名称编码：无
        ba.setDjywzmzsh(null);              //登记业务证明证书号：无

        ba.setBdcdyh(this.bdcdyh);          //不动产单元号
        ba.setFwbm(this.fwbh);              //房屋编码
        ba.setXzqhdm(qxdm);                 //行政区划代码
        ba.setQx(qxmc);                     //区县
        ba.setXzjdb("无");               //乡镇/街道办 无
        ba.setJjxzqh("无");              //交集行政区划 无
        ba.setJjxzqhdm("999999");        //交集行政区划代码999999
        ba.setLjx("无");                 //路街巷 无
        ba.setXq(this.xmmc);              //小区
        ba.setLh(this.lzmc);              //楼号

        if( this.szc == null ) {
            tszt = 0;
        }  else {
            ba.setSzzzc(this.szc);          //所在终止层
            if( this.kc != null && this.kc > 0 ) {
                ba.setSzqsc(this.szc - this.kc + 1 );          //所在起始层
            }
        }
        ba.setMyc(this.szc+"层");             //名义层
        if( this.dymc == null ) {
            this.dymc = "无";
        }
        ba.setDy(this.dymc);              //层房序号  原单元号
        ba.setFh(this.fh);              //房号
        ba.setFwzl(this.fwzl);            //房屋坐落

        String _hxmc = null;
        String _hxbm = null;
        if(this.hx != null ) {
            if( this.hx.indexOf("单户") >= 0 || this.hx.indexOf("一室") >= 0 ) {
                _hxmc = "一居室";
                _hxbm = "01";
            } else if( this.hx.indexOf("二室") >= 0 || this.hx.indexOf("两室") >= 0 ) {
                _hxmc = "二居室";
                _hxbm = "02";
            } else if( this.hx.indexOf("三室") >= 0 ) {
                _hxmc = "三居室";
                _hxbm = "03";
            } else if( this.hx.indexOf("四室") >= 0 || this.hx.indexOf("四居") >= 0 ) {
                _hxmc = "四居室";
                _hxbm = "04";
            }
        }
        if( _hxbm == null ) {
            _hxmc = "无";
            _hxbm = "99";
        }
        ba.setHxjs(_hxmc);            //户型居室  01 一居室   02 二居室   03 三居室   04 四居室   05 五居室，没有送99
        ba.setHxjsbm(_hxbm);          //户型居室编码
        ba.setHxjg("无");             //户型结构 无
        ba.setHxjgbm("99");          //户型结构编码 99
        ba.setFwcx("无");            //房屋朝向无
        ba.setFwcxbm("99");          //房屋朝向编码99

        BigDecimal _jzmj = null;        //建筑面积
        BigDecimal _tnmj = null;        //套内建筑面积
        BigDecimal _gtmj = null;      //公摊建筑面积
        if( this.jzmj != null && this.jzmj.compareTo(BigDecimal.ZERO) > 0 ) {
            ba.setJzmj(this.jzmj);
            ba.setTnjzmj(this.tnmj);
            ba.setGtjzmj(this.gtmj);
        } else {
            ba.setJzmj(this.yjzmj);
            ba.setTnjzmj(this.ytnmj);
            ba.setGtjzmj(this.ygtmj);
        }

        ba.setGhyt(this.yt);        //规划用途

        String _jzjg = null;
        String _jzjgbm = null;
        if( this.jg != null ) {
            if( this.jg.indexOf("钢结构") >= 0 ) {
                _jzjg = "钢结构";
                _jzjgbm = "01";
            } else if(this.jg.indexOf("钢和钢混") >= 0 ) {
                _jzjg = "钢、钢筋混凝土结构";
                _jzjgbm = "02";
            } else if(this.jg.indexOf("钢混") >= 0 ) {
                _jzjg = "钢筋混凝土结构";
                _jzjgbm = "03";
            } else if(this.jg.indexOf("混合") >= 0 ) {
                _jzjg = "混合结构";
                _jzjgbm = "04";
            } else if(this.jg.indexOf("砖木") >= 0 ) {
                _jzjg = "砖木结构";
                _jzjgbm = "05";
            }
        }
        if( _jzjg == null ) {
            _jzjg = "其他结构";
            _jzjgbm = "06";
        }
        ba.setJzjg(_jzjg);          //建筑结构  01 钢结构  02 钢、钢筋混凝土结构 03 钢筋混凝土结构    04 混合结构 05 砖木结构   06 其他结构
        ba.setJzjgbm(_jzjgbm);      //建筑结构编码

        String _fwyt = null;
        String _fwytbm = null;
        if( this.yt != null ) {
            if( this.yt.indexOf("住宅") >= 0 || this.yt.indexOf("阁楼") >= 0 ) {
                _fwyt = "住宅";
                _fwytbm = "001";
            } else if( this.yt.indexOf("科教") >= 0 || this.yt.indexOf("教育科研") >= 0 ) {
                _fwyt = "教育、医疗、卫生、科研";
                _fwytbm = "021";
            } else if( this.yt.indexOf("医卫") >= 0 || this.yt.indexOf("医疗") >= 0 ) {
                _fwyt = "医疗卫生";
                _fwytbm = "023";
            } else if( this.yt.indexOf("职工公寓") >= 0 ) {
                _fwyt = "集体宿舍";
                _fwytbm = "006";
            } else if( this.yt.indexOf("商业") >= 0 ) {
                _fwyt = "商业服务";
                _fwytbm = "016";
            } else if( this.yt.indexOf("办公") >= 0 ) {
                _fwyt = "办公";
                _fwytbm = "031";
            } else if( this.yt.indexOf("营业") >= 0 || this.yt.indexOf("商住") >= 0 ) {
                _fwyt = "经营";
                _fwytbm = "017";
            } else if( this.yt.indexOf("生产") >= 0 ) {
                _fwyt = "工业";
                _fwytbm = "008";
            }
        }
        if( _fwyt == null ) {
            _fwyt = "其它";
            _fwytbm = "033";
        }
        ba.setFwyt(_fwyt);          //房屋用途   001 住宅  003别墅 004 高档公寓 007工业、交通、仓储 015 商业、金融、信息 031 办公    033 其它
        ba.setFwytbm(_fwytbm);      //房屋用途编码
        ba.setFwxz("无");           //房屋性质 无
        ba.setFwxzbm("99");         //房屋性质编码 99

        String _fwlx = null;
        String _fwlxbm = null;
        if( this.fwlx != null ) {
            if( this.fwlx.equals("Z") || this.fwlx.equals("G") ) {
                _fwlx = "住宅";
                _fwlxbm = "01";
            } else if( this.fwlx.equals("S") ) {
                _fwlx = "商业用房";
                _fwlxbm = "02";
            } else if( this.fwlx.equals("C") ) {
                _fwlx = "车库";
                _fwlxbm = "06";
            }
        }
        if( _fwlx == null ) {
            _fwlx = "无";
            _fwlxbm = "99";
        }
        ba.setFwlx(_fwlx);        //房屋类型    02 商业用房 03 办公用房  04 工业用房 05 仓储用房  06 车库
        ba.setFwlxbm(_fwlxbm);      //房屋类型编码

        int gyrsl = 1;
        if( this.gyr1 != null && this.gyr1.length() > 0 ) {
            gyrsl = 2;
        }
        if( gyrsl == 1 ) {
            ba.setGyfsbm("01");      //共有方式编码
            ba.setGyfs("单独占有");
        } else {
            ba.setGyfsbm("02");      //共有方式编码
            ba.setGyfs("共同共有");
        }
        ba.setSzfe("无");        //所占份额 无
        ba.setCjje(this.fwjg);    //成交金额
        if( this.dkfs == null || this.dkfs == 0 ) {
            ba.setFklx("无抵押一次性付款");        //付款类型 01 无抵押一次性付款    02 无抵押分期付款  03 抵押贷款一次性付款  04 抵押贷款分期付款
            ba.setFklxbm("01");      //付款类型编码
            ba.setDkfs("不确定");        //贷款方式  01 商业贷款 02 公积金贷款 03 组合贷款 04 不确定  没有送04
            ba.setDkfsbm("04");      //贷款方式编码
        } else {
            ba.setFklx("抵押贷款一次性付款");
            ba.setFklxbm("03");      //付款类型编码
            if( this.dkfs == 1 ) {
                ba.setDkfs("商业贷款");
                ba.setDkfsbm("01");
            } else if( this.dkfs == 2 ) {
                ba.setDkfs("公积金贷款");
                ba.setDkfsbm("02");
            } else {
                ba.setDkfs("组合贷款");
                ba.setDkfsbm("03");
            }
        }

        if( this.ywsj == null || this.ywsj.length() < 8 ) {
            tszt = 0;
        }
        if( this.htzt == 4 && (this.basj == null || this.basj.length() < 8 )) {
            tszt = 0;
        }

        ba.setHtsxrq(this.ywsj);
        if(StringUtils.isNotBlank(this.basj)){
            ba.setYwbjsj(this.basj);     //合同生效日期  2019-01-29 16:20:00
        }else{
            ba.setYwbjsj(this.ywsj);
        }

         //业务办结时间 2019-01-29 16:20:00
        ba.setYwbjrsfzh("无");           //业务办结人身份证号  无
        ba.setYwblszxzqhdm(qxdm);       //业务办理所在行政区划代码

        if( this.htzt < 4 ) {
            ba.setBazt(1);
        } else {
            ba.setBazt(2);
        }
        ba.setTszt(tszt);
        ba.setTssj("");

        return ba;
    }


    private SjtsStFwwqba createKfs(SjtsStFwwqba ba){
        SjtsStFwwqba wq0 = new SjtsStFwwqba(ba);
        wq0.setXh(ba.getXh()+"0");
        wq0.setJyzlb("出让人");           //交易者类别： 01 出让人 05 受让方
        wq0.setJyzlbbm("01");            //交易者类别编码
        wq0.setJyzqc(this.qymc);         //交易者全称
        wq0.setJyzzjmc("统一社会信用代码证");         //交易者证件名称
        wq0.setJyzzjmcbm("02");          //交易者证件名称编码 01 居民身份证 02 社会信用代码证 03 港澳台身份证  04 护照  06 军官证（士兵证） 09 永久居留证
        wq0.setJyzzjhm(this.qyzch);       //交易者证件号码
        wq0.setJyzxz("无");              //交易者性质 01 本市城镇居民  02 本市非城镇居民 03 外省市个人  04 华侨 05 香港同胞  06 澳门同胞07 台湾同胞  08 军人09 外国个人 10 本省外市居民
        wq0.setJyzxzbm("99");           //交易者性质编码
        wq0.setJyzhj("无");              //交易者户籍： 无
        wq0.setJyzhjxzqh("999999");       //交易者户籍行政区划：有身份证号的尽量用身份证号的前6位代替，其他999999

        return wq0;
    }

    private SjtsStFwwqba createSrf(SjtsStFwwqba ba, String xm, String zjh, int idex) {
        SjtsStFwwqba wq1 = new SjtsStFwwqba(ba);
        wq1.setXh(ba.getXh()+idex);
        wq1.setJyzlb("受让方");           //交易者类别： 01 出让人 05 受让方
        wq1.setJyzlbbm("05");            //交易者类别编码
        wq1.setJyzqc(xm);               //交易者全称
        wq1.setJyzzjhm(zjh);        //交易者证件号码

        if( xm.length() <= 4 ) {
            //认为是个人
            String _xz = null;
            String _xzbm = null;
            String _xzmc = null;
            String _xzqh = null;
            if( zjh.length() == 15 || zjh.length() == 18 ){
                wq1.setJyzzjmc("居民身份证");      //交易者证件名称
                wq1.setJyzzjmcbm("01");          //交易者证件名称编码 01 居民身份证 02 社会信用代码证 03 港澳台身份证  04 护照  06 军官证（士兵证） 09 永久居留证

                _xzqh = zjh.substring(0, 6);
                if( _xzqh.indexOf("3707") == 0 ) {
                    _xz = "本市城镇居民";
                    _xzbm = "01";
                    _xzmc = "潍坊市";
                } else if( _xzqh.indexOf("37") == 0 ) {
                    _xz = "本省外市居民";
                    _xzbm = "10";
                    _xzmc = "山东省";
                } else {
                    _xz = "外省市个人";
                    _xzbm = "03";
                    _xzmc = "中国";
                }
            } else {
                wq1.setJyzzjmc("护照");      //交易者证件名称
                wq1.setJyzzjmcbm("03");          //交易者证件名称编码
                _xz = "无";
                _xzbm = "99";
                _xzqh = "999999";
                _xzmc = "无";
            }

            wq1.setJyzxz(_xz);              //交易者性质 01 本市城镇居民  02 本市非城镇居民 03 外省市个人  04 华侨 05 香港同胞  06 澳门同胞07 台湾同胞  08 军人09 外国个人 10 本省外市居民
            wq1.setJyzxzbm(_xzbm);           //交易者性质编码
            wq1.setJyzhj(_xzmc);              //交易者户籍： 无
            wq1.setJyzhjxzqh(_xzqh);       //交易者户籍行政区划：有身份证号的尽量用身份证号的前6位代替，其他999999

        } else {
            //认为是企业
            if( zjh.length() == 13 ) {
                wq1.setJyzzjmc("营业执照");              //交易者证件名称
                wq1.setJyzzjmcbm("08");                  //交易者证件名称编码
            } else if( zjh.length() == 18 ) {
                wq1.setJyzzjmc("统一社会信用代码证");      //交易者证件名称
                wq1.setJyzzjmcbm("02");                 //交易者证件名称编码
            } else {
                wq1.setJyzzjmc("护照");      //交易者证件名称
                wq1.setJyzzjmcbm("03");          //交易者证件名称编码
            }
            wq1.setJyzxz("无");              //交易者性质 01 本市城镇居民  02 本市非城镇居民 03 外省市个人  04 华侨 05 香港同胞  06 澳门同胞07 台湾同胞  08 军人09 外国个人 10 本省外市居民
            wq1.setJyzxzbm("99");           //交易者性质编码
            wq1.setJyzhj("无");              //交易者户籍： 无
            wq1.setJyzhjxzqh("999999");

        }

        return wq1;
    }

}
