package com.coob.sjts.modules.mis.domain.sjts;


import com.coob.sjts.modules.zhfg.bo.BuildAccBo;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 数据推送
 *  住建部数据推送 - 监管楼幢数据
 */
public class SjtsZjbJglz implements Serializable {
    private static final long serialVersionUID = -1L;

    private String lzid;            //楼幢ID
    private String xmbh;            //项目编号
    private String xmmc;            //项目名称
    private String lzmc;            //楼幢名称
    private BigDecimal jacb;        //建安成本
    private String jsjdbm;          //建设进度编码
    private String jsjd;            //建设进度
    private BigDecimal jged;        //监管额度
    private BigDecimal lcbl;        //留存比例
    private BigDecimal lced;        //留存额度
    private BigDecimal ye;          //余额
    private Integer zzht;           //纸质合同 0没有 1有
    private Integer dzht;           //电子合同 0没有 1有
    private String jfrq;            //交付日期
    private Integer zt;             //状态  1在建  2交付 3手工改为交付


    /**
     *
     */

    public void initJsjd() {
        /*
            无进度(100)
            完成地下结构(200)
            主体结构封顶(300)
            未竣工验收备案已交付(301)
            完成竣工验收备案未交付(400)
            完成竣工验收备案交付中(401)
            完成房屋所有权首次登记未交付(500)
            完成房屋所有权首次登记交付中(501)
         */

        double bl = this.lcbl.doubleValue();
        if( bl >= 90 ) {
            this.jsjd = "完成地下结构";
            this.jsjdbm = "200";
        } else if( bl > 35) {
            this.jsjd = "完成地下结构";
            this.jsjdbm = "200";
        } else if( bl > 20 ) {
            this.jsjd = "主体结构封顶";
            this.jsjdbm = "300";
        } else if( bl > 0 ) {
            this.jsjd = "完成竣工验收备案未交付";
            this.jsjdbm = "400";
        } else {
            this.jsjd = "完成房屋所有权首次登记交付中";
            this.jsjdbm = "501";
        }

        if( this.jsjdbm.equals("501") ) {
            this.lced = BigDecimal.ZERO;
        }
    }

    public boolean checkChange(BuildAccBo bo){
        boolean flag = false;

        if( bo.getLcbl().compareTo(this.lcbl) < 0 ){
            flag = true;
            this.lcbl = bo.getLcbl();
            this.initJsjd();
        }

        if( bo.getLced().compareTo(this.lced) < 0 ) {
            flag = true;
            this.lced = bo.getLced();
        }

        return flag;
    }


    public String getLzid() { return this.lzid; }

    public void setLzid(String lzid) { this.lzid = lzid; }

    public String getXmbh() { return this.xmbh; }

    public void setXmbh(String xmbh) { this.xmbh = xmbh; }

    public String getXmmc() { return this.xmmc; }

    public void setXmmc(String xmmc) { this.xmmc = xmmc; }

    public String getLzmc() { return this.lzmc; }

    public void setLzmc(String lzmc) { this.lzmc = lzmc; }

    public BigDecimal getJacb() { return this.jacb; }

    public void setJacb(BigDecimal jacb) { this.jacb = jacb; }

    public String getJsjd() { return this.jsjd; }

    public void setJsjd(String jsjd) { this.jsjd = jsjd; }

    public BigDecimal getJged() { return this.jged; }

    public void setJged(BigDecimal jged) { this.jged = jged; }

    public BigDecimal getLcbl() { return this.lcbl; }

    public void setLcbl(BigDecimal lcbl) { this.lcbl = lcbl; }

    public BigDecimal getLced() { return this.lced; }

    public void setLced(BigDecimal lced) { this.lced = lced; }

    public BigDecimal getYe() { return this.ye; }

    public void setYe(BigDecimal ye) { this.ye = ye; }

    public Integer getZt() { return this.zt; }

    public void setZt(Integer zt) { this.zt = zt; }

    public Integer getZzht() {
        return zzht;
    }

    public void setZzht(Integer zzht) {
        this.zzht = zzht;
    }

    public Integer getDzht() {
        return dzht;
    }

    public void setDzht(Integer dzht) {
        this.dzht = dzht;
    }

    public String getJsjdbm() {
        return jsjdbm;
    }

    public void setJsjdbm(String jsjdbm) {
        this.jsjdbm = jsjdbm;
    }

    public String getJfrq() {
        return jfrq;
    }

    public void setJfrq(String jfrq) {
        this.jfrq = jfrq;
    }
}
