package com.coob.sjts.modules.mis.mapper;


import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.mis.domain.sjts.SjtsStJglz;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_MIS)
public interface SjtsStJglzMapper {

    /**
     * 批量新增信息
     * @return
     */
    int insertSelect();

    /**
     *  根据住建部导入新增数据
     * @return
     */
    int insertSelectByZjb();


    /**
     * 根据住建部信息更新监管楼幢信息
     * @return
     */
    int updateJgByZjb();

    /**
     * 更新监管楼幢的建设进度以及状态
     * @return
     */
    int updateZtorJd();

    /**
     * 更新监管楼幢的交付日期
     * @return
     */
    int updateJfrq();



    /**
     * 查询所有列表
     * @return
     */
    List<SjtsStJglz> selectListAll();

    /**
     * 查询在建的项目信息列表
     * @return
     */
    List<SjtsStJglz> selectXmxxZjList();



    /**
     * 统计监管楼幢数量
     * @return
     */
    int countJglz();
}
