package com.coob.sjts.modules.mis.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.mis.domain.sjts.SjtsStJgzhmx;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 数据推送 - 省厅 - 监管账户明细表
 *  数据处理
 *
 * @author makejava
 * @since 2024-05-19 15:24:21
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_MIS)
public interface SjtsStJgzhmxMapper {

    /**
     * 新增数据
     *  根据 sjts_zjb_jgzhmx 表增量插入
     *  执行前，需要先更新 sjts_zjb_jgzhmx 表数据
     * @return
     */
    int insertSelect();

    /**
     * 批量修改
     *  根据 sjts_zjb_jgzhmx 表更新数据
     *  执行前，需要先更新 sjts_zjb_jgzhmx 表数据
     * @return
     */
    int updateSelect();

    /**
     * 更新推送时间，推送状态为2
     * @param tssj
     * @return
     */
    int uppdateTszt( );


    /**
     * 删除所有数据
     * @return
     */
    int deleteAll();

    /**
     * 查询所有列表
     * @return
     */
    List<SjtsStJgzhmx> selectListAll();


    /**
     * 查询所有未推送的监管账户信息
     * @return
     */
    List<SjtsStJgzhmx> selectListByWts();


}

