package com.coob.sjts.modules.mis.mapper;


import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.mis.domain.sjts.SjtsStWqba;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * (SjtsSnXmxx)表数据库访问层
 *
 * @author makejava
 * @since 2024-05-19 15:24:21
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_MIS)
public interface SjtsStWqbaMapper {


    /**
     * 新增网签备案预售信息导入
     * @return
     */
    int insertSelectYs();


    /**
     * 新增网签备案现售信息导入
     * @return
     */
    int insertSelectXs();

    /**
     * 更新网签备案套数 面积
     * @return
     */
    int updateBa();

    /**
     * 更新住宅备案套数   面积  金额
     * @return
     */
    int updateZzba();

    /**
     * 更新商业备案套数   面积   金额
     * @return
     */
    int updateSyba();

    /**
     * 更新其他面积
     * @return
     */
    int updateQtmj();

    /**
     * 更新本年备案套数  面积 金额
     * @return
     */
    int updateBnba();

    /**
     * 更新本年住宅备案套数  面积 金额
     * @return
     */
    int updateBnZZba();

    /**
     * 更新本年商业备案套数  面积 金额
     * @return
     */
    int updateBnSYba();

    /**
     * 更新已交付楼幢的历史交付套数
     * @return
     */
    int updateLsjf();

    /**
     * 更新推送时间，推送状态为2
     * @param tssj
     * @return
     */
    int uppdateTsztOrTssj( );


    /**
     * 根据网签类型查询所有数据
     * @return
     */
    List<SjtsStWqba> selectAllList();

    /**
     * 查询所有未推送的网签备案数据
     * @return
     */
    List<SjtsStWqba> selectListByWTs();

}

