package com.coob.sjts.modules.mis.mapper;


import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.mis.bo.GrzfTjBo;
import com.coob.sjts.modules.mis.bo.GrzfTjMjBo;
import com.coob.sjts.modules.mis.bo.GrzfTjNlBo;
import com.coob.sjts.modules.mis.bo.GrzfTjQyBo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.transaction.annotation.Transactional;

/**
 * 开发商建设用地规划许可证(YsXmyd)表数据库访问层
 *
 * @author Awei
 * @since 2023-11-14 17:54:39
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_MIS)
public interface YsHtlsbMsrMapper {


    /**
     * 根据住宅统计
     * @return
     */
    GrzfTjBo countGrzfTjByZz(@Param("tsks")Integer tsks,@Param("tsjz")Integer tsjz);


    /**
     * 统计全部房屋用途
     * @return
     */
    GrzfTjBo countGrzfTj(@Param("tsks")Integer tsks,@Param("tsjz")Integer tsjz);


    /**
     * 根据年龄统计购房信息
     * @param ksnl 开始年龄，包含开始年龄值
     * @param jznl  截止年龄 不包含截止年龄值  如ksnl=0  jznl = 20 实际查询的是0--19的
     * @return
     */
    GrzfTjNlBo countGrzfTjNl(@Param("ksnl")Integer ksnl,@Param("jznl")Integer jznl);

    /**
     * 根据区域划分统计购房信息
     * @param qy 1寿光  2潍坊  3山东  4其他
     * @return
     */
    GrzfTjQyBo countGrzfTjQy(@Param("qy")Integer qy);

/**
 * 根据面积统计个人购房信息 -所有
 */
    GrzfTjMjBo countGrzfTjMj();

/**
 * 根据面积统计个人购房信息 -住宅
 */
    GrzfTjMjBo countGrzfTjZzMj();




}

