package com.coob.sjts.modules.mis.mapper;


import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.mis.domain.wk.YsQyzzqk;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 注册开发商资质情况(YsQyzzqk)表数据库访问层
 *
 * @author Awei
 * @since 2023-11-15 17:22:35
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_MIS)
public interface YsQyzzqkMapper  {

    /**
     * 根据qyid查询资质信息
     * @param qyid
     * @return
     */
    YsQyzzqk selectByQyid(Integer qyid);

    /**
     * 查询所有id大于之前oldId的数据
     * @param oldId
     * @return
     */
    List<YsQyzzqk> selectByOldId(Integer oldId);

    /**
     * 查询所有资质信息
     * @return
     */
    List<YsQyzzqk> selectAllList();


}

