package com.coob.sjts.modules.mis.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.mis.domain.sjts.SjtsStXmxx;
import com.coob.sjts.modules.mis.domain.wk.YsXmgc;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 *
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_MIS)
public interface YsXmgcMapper {


    /**
     * 根据企业id查询工程证信息
     * @param qyid
     * @return
     */
    List<YsXmgc> selectByQyid(Integer qyid);


    /**
     * 查询id大于oldId的工程证信息
     * @param oldId
     * @return
     */
    List<YsXmgc> selectByOldId(Integer oldId);

    /**
     * 查询所有工程证信息
     * @return
     */
    List<YsXmgc> selectAllList();



    /**
     * 根据项目编号查询所有的工程规划证信息
     * @return
     */
    List<SjtsStXmxx> selectZshByXmid( );

}




