package com.coob.sjts.modules.mis.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.mis.domain.sjts.SjtsStXmxx;
import com.coob.sjts.modules.mis.domain.wk.YsXmsg;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 *
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_MIS)
public interface YsXmsgMapper {


    /**
     * 根据企业id查询施工证信息
     * @param qyid
     * @return
     */
    List<YsXmsg> selectByQyid(Integer qyid);

    /**
     * 查询所有id大于oldId的施工证信息
     * @param oldId
     * @return
     */
    List<YsXmsg> selectByOldId(Integer oldId);

    /**
     * 查询所有施工证信息
     * @return
     */
    List<YsXmsg> selectAllList();

    /**
     * 根据项目编号字符串查询所有项目的开工日期以及计划竣工日期
     * @param xmbhs
     * @return
     */
    List<SjtsStXmxx> selectKgsjByXmbh();




}




