package com.coob.sjts.modules.mis.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.mis.domain.sjts.SjtsStXmxx;
import com.coob.sjts.modules.mis.domain.wk.YsXmtd;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;


/**
 * (YsXmtd)表数据库访问层
 *
 * @author Awei
 * @since 2023-11-14 17:49:57
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_MIS)
public interface YsXmtdMapper {

    /**
     * 根据企业id查询土地证信息
     * @param qyid
     * @return
     */
    List<YsXmtd> selectByQyid(Integer qyid);

    /**
     * 查询所有id大于oldId的土地证信息
     * @param oldId
     * @return
     */
    List<YsXmtd> selectByOldId(Integer oldId);

    /**
     * 查询所有土地证信息
     * @return
     */
    List<YsXmtd> selectAllList();

    /**
     * 根据项目编号查询所有的土地使用证信息
     * @param xmid
     * @return
     */
    List<SjtsStXmxx> selectZshByXmid( );
}

