package com.coob.sjts.modules.mis.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.mis.domain.wk.YsXmxx;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * (YsXmxx)表数据库访问层
 *
 * @author Awei
 * @since 2023-11-15 14:55:09
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_MIS)
public interface YsXmxxMapper {


    /**
     * 查询所有项目信息
     * @return
     */
    List<YsXmxx> selectAllList();


    /**
     * 根据企业id查询该企业的所有项目信息
     * @param qyid
     * @return
     */
    List<YsXmxx> selectByQyid(Integer qyid);


    /**
     * 查询所有id大于之前oldId的数据
     * @param oldId
     * @return
     */
    List<YsXmxx> selectByOldId(Integer oldId);



}

