package com.coob.sjts.modules.mis.mapper;


import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.mis.domain.sjts.SjtsStXmxx;
import com.coob.sjts.modules.mis.domain.wk.YsXmyd;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 开发商建设用地规划许可证(YsXmyd)表数据库访问层
 *
 * @author Awei
 * @since 2023-11-14 17:54:39
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_MIS)
public interface YsXmydMapper{

    /**
     * 根据企业id查询用地证信息
     * @param qyid
     * @return
     */
    List<YsXmyd> selectByQyid(Integer qyid);

    /**
     * 查询所有id大于oldId的用地证信息
     * @param oldId
     * @return
     */
    List<YsXmyd> selectByOldId(Integer oldId);

    /**
     * 查询所有用地证信息
     * @return
     */
    List<YsXmyd> selectAllList();

    /**
     * 根据项目编号查询所有的建设用地规划许可证信息
     * @param
     * @return
     */
    List<SjtsStXmxx> selectZshByXmid();
}

