package com.coob.sjts.modules.mis.service;

import com.coob.sjts.modules.mis.bo.GrzfTjBo;
import com.coob.sjts.modules.mis.bo.GrzfTjMjBo;
import com.coob.sjts.modules.mis.bo.GrzfTjNlBo;
import com.coob.sjts.modules.mis.bo.GrzfTjQyBo;
import com.coob.sjts.modules.mis.mapper.YsHtlsbMsrMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 *
 *
 * @author Awei
 * @since 2024-06-24
 */
@Service
public class YsHtlsbMsrService {
    @Resource
    private YsHtlsbMsrMapper msrMapper;


    /**
     * 根据住宅统计
     * @param tsks
     * @param tsjz
     * @return
     */

    public GrzfTjBo countGrzfTjByZz(Integer tsks,Integer tsjz) {
        return msrMapper.countGrzfTjByZz(tsks,tsjz);
    }

    /**
     * 统计全部房屋用途
     * @param tsks
     * @param tsjz
     * @return
     */
    public GrzfTjBo countGrzfTj(Integer tsks,Integer tsjz) {
        return msrMapper.countGrzfTj(tsks,tsjz);
    }


    /**
     * 根据年龄区间统计购房信息
     * @param ksnl
     * @param jznl
     * @return
     */
    public GrzfTjNlBo countGrzfTjNl(Integer ksnl, Integer jznl) {
        return msrMapper.countGrzfTjNl(ksnl,jznl);
    }


    /**
     * 根据区域统计购房信息
     * @param qy
     * @return
     */
    public GrzfTjQyBo countGrzfTjByQy(Integer qy) {
        return msrMapper.countGrzfTjQy(qy);
    }

    /**
     * 根据面积统计个人购房信息 --所有
     * @return
     */
    public GrzfTjMjBo countGrzfTjMj(){
        return msrMapper.countGrzfTjMj();
    }

    /**
     * 根据面积统计个人购房信息 --住宅
     * @return
     */
    public GrzfTjMjBo countGrzfTjZzMj(){
        return msrMapper.countGrzfTjZzMj();
    }


}
