package com.coob.sjts.modules.mis.service.sjts;


import com.coob.sjts.modules.mis.domain.sjts.SjtsZjbJglz;
import com.coob.sjts.modules.mis.domain.sjts.SjtsZjbJgzhmx;
import com.coob.sjts.modules.mis.domain.sjts.SjtsZjbWqba;
import com.coob.sjts.modules.mis.domain.sjts.SjtsZjbYsxkz;
import com.coob.sjts.modules.mis.mapper.SjtsZjbJglzMapper;
import com.coob.sjts.modules.mis.mapper.SjtsZjbJgzhmxMapper;
import com.coob.sjts.modules.mis.mapper.SjtsZjbWqbaMapper;
import com.coob.sjts.modules.mis.mapper.SjtsZjbYsxkzMapper;
import com.coob.sjts.modules.zhfg.bo.BuildAccBo;
import com.coob.sjts.modules.zhfg.bo.ProjectAccBo;
import com.coob.sjts.modules.zhfg.mapper.FcAccountMapper;
import com.coob.sjts.modules.zhfg.mapper.FcBuildingAccountMapper;
import com.coob.sjts.modules.zhfg.mapper.FcProjectAccountMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;


/**
 * 住建部 - 预售监管推送数据处理
 */
@Service
public class SjtsZjbService {
    @Resource
    private SjtsZjbJglzMapper sjtsZjbJglzMapper;
    @Resource
    private SjtsZjbYsxkzMapper sjtsZjbYsxkzMapper;
    @Resource
    private SjtsZjbWqbaMapper sjtsZjbWqbaMapper;
    @Resource
    private SjtsZjbJgzhmxMapper sjtsZjbJgzhmxMapper;
    @Resource
    private FcAccountMapper fcAccountMapper;
    @Resource
    private FcBuildingAccountMapper fcBuildingAccountMapper;
    @Resource
    private FcProjectAccountMapper fcProjectAccountMapper;



    /******************************************************************************************/
    /***********************************统计监管楼幢*********************************************/
    public void createJglz() {
        //查询预售资金监管系统的 监管楼幢数据
        List<BuildAccBo> boList = this.fcBuildingAccountMapper.selectListForSjts();

        //查询本地监管楼幢表
        List<SjtsZjbJglz> oList = this.selectJglzListAll();

        //比对数据
        List<SjtsZjbJglz> addList = new ArrayList<>();
        List<SjtsZjbJglz> edtList = new ArrayList<>();

        int flag = 0;
        for( BuildAccBo bo : boList ) {
            flag = 0;
            for( SjtsZjbJglz lz : oList ) {
                if( bo.getLzbh().equals(lz.getLzid()) ) {
                    flag = 1;
                    if( lz.getZt() == 1 ) {
                        if( lz.checkChange(bo) ) {
                            edtList.add(lz);
                        }
                    }
                    break;
                }
            }

            if( flag == 0 ) {
                SjtsZjbJglz nl = bo.createZjbLz();
                nl.initJsjd();
                addList.add(nl);
            }
        }
        this.imptJglz(addList, edtList);

    }

    /**
     * 导入监管楼幢数据
     * @param addList
     * @param edtList
     * @return
     */
    public int imptJglz(List<SjtsZjbJglz> addList, List<SjtsZjbJglz> edtList){
        System.out.println(" >> 导入监管楼幢数据  >> ");

        int flag = 0;

        //添加新数据
        if( addList != null && !addList.isEmpty() ) {
            flag = this.sjtsZjbJglzMapper.insertBatch(addList);
            System.out.println("  > 添加新数据：" + flag);
        }

        //修改数据
        if( edtList != null && !edtList.isEmpty() ) {
            flag = this.sjtsZjbJglzMapper.updateBatch(edtList);
            System.out.println("  > 修改数据：" + flag);
        }

        //检查是否权证发放
        flag = this.sjtsZjbJglzMapper.updateZtByQzff();
        System.out.println("  > 权证发放数据：" + flag );

        //按项目更新是否签署过纸质合同（备案的）
        flag = this.sjtsZjbJglzMapper.updateZzht();
        System.out.println("  > 按项目更新是否签署过纸质合同：" + flag );

        //按项目更新是否签署过电子合同
        flag = this.sjtsZjbJglzMapper.updateDzht();
        System.out.println("  > 按项目更新是否签署过电子合同：" + flag );

        //根据合同变更zt，签署过纸质合同、但未签署过电子合同的，认为是老项目
        flag = this.sjtsZjbJglzMapper.updateZtByHt();
        System.out.println("  > 据合同变更zt：" + flag );

        //更新合同约定交付日期 - 按楼幢更新
        flag = this.sjtsZjbJglzMapper.updateJfrqByLz();
        System.out.println("  > 约定交付日期1：" + flag );

        //更新合同约定交付日期 - 按项目更新
        flag = this.sjtsZjbJglzMapper.updateJfrqByXm();
        System.out.println("  > 约定交付日期2：" + flag );

        return 1;
    }


    /******************************************************************************************/
    /******************************住建部预售许可证数据更新****************************************/

    /**
     * 生成预售许可证数据
     * @return
     */
    public int imptYskxz(){
        System.out.println(" >> 导入 预售许可证数据  >> ");

        int flag = 0;

        //查询导入新增数据
        flag = this.sjtsZjbYsxkzMapper.insertSelect();
        System.out.println("  > 添加新数据：" + flag );

        //更新预售套数、面积
        flag = this.sjtsZjbYsxkzMapper.updateYstsmj();
        System.out.println("  > 更新预售套数、面积：" + flag );

        //更新住宅套数面积
        flag = this.sjtsZjbYsxkzMapper.updateYszztsmj();
        System.out.println("  > 更新住宅套数面积：" + flag );

        //更新商业面积
        flag = this.sjtsZjbYsxkzMapper.updateYssymj();
        System.out.println("  > 更新商业面积：" + flag );

        //更新其他面积
        flag =  this.sjtsZjbYsxkzMapper.updateYsqtmj();
        System.out.println("  > 更新其他面积：" + flag );

        //更新工程进度
        flag = this.sjtsZjbYsxkzMapper.updateGcjsjd();
        System.out.println("  > 更新工程进度：" + flag );

        //更新完工数据
        flag = this.sjtsZjbYsxkzMapper.updateGcjdWc();
        System.out.println("  > 更新完工数据：" + flag );

        return 1;
    }

    /******************************************************************************************/
    /**************************************住建部网签备案数据导入**********************************/
    /**
     * 生成预售许可证数据
     * @return
     */
    public int imptWqba(){
        System.out.println(" >> 导入 网签备案数据  >> ");

        int flag = 0;

        //1、查询导入新增数据
        flag = this.sjtsZjbWqbaMapper.insertSelect();
        System.out.println("  > 添加新数据：" + flag );

        //2、更新网签备案套数
        flag = this.sjtsZjbWqbaMapper.updateWqbats();
        System.out.println("  > 更新网签备案套数：" + flag );

        //3、更新网签备案 住宅 套数
        flag = this.sjtsZjbWqbaMapper.updateWqbazzts();
        System.out.println("  > 更新网签备案 住宅 套数：" + flag );

        //4、更新网签备案 商业 面积
        flag = this.sjtsZjbWqbaMapper.updateWqbasymj();
        System.out.println("  > 更新网签备案 商业 面积：" + flag );

        //5、更新网签备案 其他 面积
        flag =  this.sjtsZjbWqbaMapper.updateWqbaqtmj();
        System.out.println("  > 更新网签备案 其他 面积：" + flag );

        //6、更新历史交付套数面积
        flag = this.sjtsZjbWqbaMapper.updateLjysjfts();
        System.out.println("  > 更新历史交付套数面积：" + flag );

        return 1;
    }
    /******************************************************************************************/
    /***********************************住建部监管账户明细 ***************************************/

    /**
     * 创建住建部监管账户明细数据
     */
    public void createJgzhmx(){

        //查询 预售资金监管系统 托管、监管账户列表
        List<ProjectAccBo> accList = this.selectProjectAccListForSjts();

        //查询本地生成的监管楼幢信息， 仅查询在建项目
        List<SjtsZjbJglz> xmList = this.selectJglzXmxxList();

        //比对 预售资金账户 和 本地监管楼幢， 仅在建项目作为有效数据s
        List<SjtsZjbJgzhmx> zhList = this.selectJgzhmxListAll();

        //比对本地已经添加的账户信息，判断是否存在、是否变更
        List<SjtsZjbJgzhmx> addList = new ArrayList<>();
        List<SjtsZjbJgzhmx> edtList = new ArrayList<>();

        int flag = 0;
        SjtsZjbJglz xmlz = null;

        for( ProjectAccBo acc : accList ) {
            //判断是否为在建项目
            flag = 0;
            for( SjtsZjbJglz l : xmList ) {
                if( l.getXmbh().equals(acc.getXmbh()) ) {
                    flag = 1;
                    xmlz = l;
                    break;
                }
            }
            if( flag == 0 ) continue;

            //判断本地是否存在
            flag = 0;
            for( SjtsZjbJgzhmx mx: zhList ) {
                if( mx.getXh().equals(acc.getZhid().toString()) ) {
                    flag = 1;
                    if( mx.checkEdit(acc, xmlz) ) {
                        //判断是否变更
                        edtList.add(mx);
                    }
                }
            }

            if( flag == 0 ) {
                //新增信息
                SjtsZjbJgzhmx zhmx = acc.createJgzhmx(xmlz);
                addList.add(zhmx);
            }
        }
        this.imptJgzhmx(addList, edtList);
    }

    /**
     * 保存数据
     * @param addList
     * @param edtList
     * @return
     */
    public int imptJgzhmx(List<SjtsZjbJgzhmx> addList, List<SjtsZjbJgzhmx> edtList){
        int flag = 0;

        if( addList != null && addList.size() > 0 ) {
            flag += this.sjtsZjbJgzhmxMapper.insertBatch(addList);
        }

        if( edtList != null && edtList.size() > 0 ) {
            flag += this.sjtsZjbJgzhmxMapper.updateBatch(edtList);
        }

        return flag;
    }


    /**
     * 查询当前有效的托管、监管账户信息
     *  用于生成省厅推送数据 - 监管账户明细
     * @return
     */
    private List<ProjectAccBo> selectProjectAccListForSjts() {
        //查询托管账户列表
        List<ProjectAccBo> tgList = this.fcProjectAccountMapper.selectTgzhListForSjts();

        //查询监管账户列表
        List<ProjectAccBo> jgList = this.fcAccountMapper.selectJgzhListForSjts();
        for( ProjectAccBo bo : jgList ) {
            bo.resetJgyxbh();
            tgList.add(bo);
        }

        return tgList;
    }

    /******************************************************************************************/
    /*************************************数据查询**********************************************/

    /**
     * 根据状态查询列表
     * @param zt
     * @return
     */
    public List<SjtsZjbJglz> selectJglzListByZt(Integer zt){
        return this.sjtsZjbJglzMapper.selectListByZt(zt);
    }

    /**
     * 查询所有列表
     * @return
     */
    public List<SjtsZjbJglz> selectJglzListAll(){
        return this.sjtsZjbJglzMapper.selectListAll();
    }

    /**
     * 查询在建的项目信息列表
     * @return
     */
    public List<SjtsZjbJglz> selectJglzXmxxList(){
        return this.sjtsZjbJglzMapper.selectXmxxList();
    }

    /**
     * 查询所有的预售许可证列表
     * @return
     */
    public  List<SjtsZjbYsxkz> selectYsxkzListAll() {
        return sjtsZjbYsxkzMapper.selectListAll();
    }

    /**
     * 查询所有的预售许可证列表
     * @return
     */
    public  List<SjtsZjbWqba> selectWqbaLisAll() {
        return sjtsZjbWqbaMapper.selectLisAll();
    }

    /**
     * 查询所有列表
     * @return
     */
    public List<SjtsZjbJgzhmx> selectJgzhmxListAll() {
        return this.sjtsZjbJgzhmxMapper.selectListAll();
    }
}
