package com.coob.sjts.modules.system.domain;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.StringUtils;

/**
 * @author : wangqingli
 * @Description: 简要功能描述
 * @date 2024-06-07-16:17
 * @modify by：wangqingli
 */
@Data
@NoArgsConstructor
public class BaseEntry {
    @ApiModelProperty(value = "系统名称")
    private String sysCode;
    @ApiModelProperty(value = "归属类型 0主管部门 1-开发 2-中介 3-测绘 4-物业 5-金融")
    private Integer gsbmType;

    public String checkParams() {
        if (StringUtils.isBlank(this.sysCode)) {
            return "系统编码不能为空";
        }
        if (this.gsbmType != null && !this.gsbmType.equals(0) && !this.gsbmType.equals(1)
                && !this.gsbmType.equals(2) && !this.gsbmType.equals(3) && !this.gsbmType.equals(5)) {
            return "所属部门类型非法";
        }
        return null;
    }
}
