package com.coob.sjts.modules.system.domain;


import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.StringUtils;

import java.io.Serializable;

/**
 * 菜单表
 *
 * @author Administrator
 */
@Data
@NoArgsConstructor
public class SysMenu extends BaseEntry implements Serializable {

    private static final long serialVersionUID = -958782978662907406L;

    /**
     * 主键
     */
    private Integer id;
    @ApiModelProperty(value = "上级菜单ID")
    private Integer parentId;
    @ApiModelProperty(value = "菜单名称")
    private String title;
    @ApiModelProperty(value = "菜单名称， 0、目录 1、菜单 2、按钮")
    private Integer menuType;
    @ApiModelProperty(value = "状态 1有效  5 禁用 -9 删除")
    private Integer state;

    @ApiModelProperty(value = "访问地址")
    private String url;
    @ApiModelProperty(value = "权限标识")
    private String perms;
    @ApiModelProperty(value = "顺序号")
    private Integer sn;


    public String checkAddParams() {
        if (this.parentId == null) {
            return "父级菜单不能为空";
        }
        if (StringUtils.isBlank(this.title)) {
            return "菜单名称不能为空";
        }
        if (this.menuType != null && !this.menuType.equals(0)
                && !this.menuType.equals(1) && !this.menuType.equals(2)) {
            return "菜单类型非法";
        }
        return checkParams();
    }

    public String checkEditParams() {
        if (this.id == null) {
            return "id不能为空";
        }
        return checkAddParams();
    }
}

