package com.coob.sjts.modules.system.domain;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.StringUtils;

import java.io.Serializable;
import java.util.Date;

/**
 * 主管部门用户
 *
 * @author Administrator
 */
@Data
@NoArgsConstructor
public class SysUser extends BaseEntry implements Serializable {

    private static final long serialVersionUID = -815738679701987296L;
    @ApiModelProperty(value = "主键", hidden = true)
    private Integer id;
    @ApiModelProperty(value = "mis库用户id")
    private String misId;
    @ApiModelProperty(value = "组织、部门id")
    private Integer orgDeptId;
    @ApiModelProperty(value = "账户")
    private String account;
    @ApiModelProperty(value = "密码")
    private String password;
    @ApiModelProperty(value = "姓名")
    private String xm;
    @ApiModelProperty(value = "密码类型  0-明码、 1-DES1  2-DES2  5-MD5")
    private Integer pwdType;
    @ApiModelProperty(value = "身份证号")
    private String sfzh;
    @ApiModelProperty(value = "电话")
    private String phone;
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    @ApiModelProperty(value = "数据状态1、正常 5、停权（禁用） -9 删除", hidden = true)
    private Integer state;


    // 非数据库字段
//    @ApiModelProperty(value = "部门名称")
//    private String orgDeptName;

    public String checkAddParams() {
        if (StringUtils.isBlank(this.account)) {
            return "账户不能为空";
        }
        if (StringUtils.isBlank(this.password)) {
            return "密码不能为空";
        }
        if (this.orgDeptId == null) {
            return "用户未选择部门";
        }
        return checkParams();
    }

    public String checkEditParams() {
        if (this.id == null) {
            return "id不能为空";
        }
        return checkAddParams();
    }

    public String checkLogin() {
        if (StringUtils.isBlank(this.account)) {
            return "账户不能为空";
        }
        if (StringUtils.isBlank(this.password)) {
            return "密码不能为空";
        }
        return null;
    }
}

