package com.coob.sjts.modules.system.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.system.domain.SysMenu;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 菜单表(SysMenu)表数据库访问层
 *
 * @author wangqingli
 * @since 2024-05-30 14:11:01
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_SYS)
public interface SysMenuMapper {


    /**
     * 新增数据
     *
     * @param sysMenu 实例对象
     * @return 影响行数
     */
    boolean insert(SysMenu sysMenu);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    boolean deleteById(Long id);

    /**
     * 修改数据
     *
     * @param sysMenu 实例对象
     * @return 影响行数
     */
    boolean update(SysMenu sysMenu);

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    SysMenu selectById(Long id);

    /**
     * 通过ID查询单条数据
     *
     * @param sysMenu 主键
     * @return 实例对象
     */
    List<SysMenu> selectList(SysMenu sysMenu);


}

