package com.coob.sjts.modules.system.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.system.domain.SysRole;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 角色(SysRole)表数据库访问层
 *
 * @author wangqingli
 * @since 2024-05-30 14:11:22
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_SYS)
public interface SysRoleMapper {

    /**
     * 新增数据
     *
     * @param sysRole 实例对象
     * @return 影响行数
     */
    boolean insert(SysRole sysRole);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    boolean deleteById(Long id);

    /**
     * 修改数据
     *
     * @param sysRole 实例对象
     * @return 影响行数
     */
    boolean update(SysRole sysRole);


    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    SysRole selectById(Long id);

    /**
     * 查询指定行数据
     *
     * @param sysRole 查询条件
     * @return 对象列表
     */
    List<SysRole> selectList(SysRole sysRole);

}

