package com.coob.sjts.modules.system.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.system.domain.SysRoleMenu;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 角色菜单(SysRoleMenu)表数据库访问层
 *
 * @author wangqingli
 * @since 2024-05-30 14:11:43
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_SYS)
public interface SysRoleMenuMapper {

    /**
     * 新增数据
     *
     * @param sysRoleMenu 实例对象
     * @return 影响行数
     */
    boolean insert(SysRoleMenu sysRoleMenu);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysRoleMenu> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<SysRoleMenu> entities);

    /**
     * 通过角色删除数据
     *
     * @return 影响行数
     */
    boolean deleteByRoleId(Long roleId);

    /**
     * 通过菜单删除数据
     *
     * @return 影响行数
     */
    boolean deleteByUserId(Long userId);

}

