package com.coob.sjts.modules.system.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.system.domain.SysUserRole;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * (SysUserRole)表数据库访问层
 *
 * @author wangqingli
 * @since 2024-05-30 14:12:09
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_SYS)
public interface SysUserRoleMapper {

    /**
     * 新增数据
     *
     * @param sysUserRole 实例对象
     * @return 影响行数
     */
    boolean insert(SysUserRole sysUserRole);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysUserRole> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<SysUserRole> entities);

    /**
     * @return
     */
    boolean deleteByRoleId(Long roleId);

    /**
     * @return
     */
    boolean deleteByUserId(Long userId);

}

