package com.coob.sjts.modules.system.service;

import com.coob.sjts.modules.system.domain.SysMenu;
import com.coob.sjts.modules.system.mapper.SysMenuMapper;
import com.coob.sjts.modules.system.mapper.SysRoleMenuMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 菜单表(SysMenu)表服务实现类
 *
 * @author wangqingli
 * @since 2024-05-30 14:11:01
 */
@Service("sysMenuService")
public class SysMenuService {
    @Resource
    private SysMenuMapper sysMenuMapper;
    @Resource
    private SysRoleMenuMapper sysRoleMenuMapper;

    /**
     * 新增数据
     *
     * @param sysMenu 实例对象
     * @return 是否成功
     */

    public boolean insert(SysMenu sysMenu) {
        return this.sysMenuMapper.insert(sysMenu);
    }


    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */

    public boolean deleteById(Long id) {
        return this.sysMenuMapper.deleteById(id);
    }

    /**
     * 修改数据
     *
     * @param sysMenu 实例对象
     * @return 是否成功
     */

    public boolean update(SysMenu sysMenu) {
        return this.sysMenuMapper.update(sysMenu);
    }



    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */

    public SysMenu selectById(Long id) {
        return this.sysMenuMapper.selectById(id);
    }

    public List<SysMenu> selectMenuByRoleId(Long roleId) {
        return null;
    }
}
