package com.coob.sjts.modules.system.service;

import com.coob.sjts.modules.system.domain.SysRoleMenu;
import com.coob.sjts.modules.system.mapper.SysRoleMenuMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 角色菜单(SysRoleMenu)表数据库访问层
 *
 * @author wangqingli
 * @since 2024-05-30 14:11:43
 */
@Service
public class SysRoleMenuService {

    @Resource
    SysRoleMenuMapper sysRoleMenuMapper;

    /**
     * 新增数据
     *
     * @param sysRoleMenu 实例对象
     * @return 影响行数
     */
    public boolean insert(SysRoleMenu sysRoleMenu) {
        return sysRoleMenuMapper.insert(sysRoleMenu);
    }

    /**
     * 批量新增数据
     *
     * @param entities List<SysRoleMenu> 实例对象列表
     * @return 影响行数
     */
    public int insertBatch(List<SysRoleMenu> entities) {
        return sysRoleMenuMapper.insertBatch(entities);
    }



    /**
     * 通过角色删除数据
     *
     * @return 影响行数
     */
    public boolean deleteByRoleId(Long roleId) {
        return sysRoleMenuMapper.deleteByRoleId(roleId);
    }

    /**
     * 通过菜单删除数据
     *
     * @return 影响行数
     */
    public boolean deleteByUserId(Long userId) {
        return sysRoleMenuMapper.deleteByUserId(userId);
    }

}

