package com.coob.sjts.modules.system.service;

import com.coob.sjts.modules.system.domain.SysRole;
import com.coob.sjts.modules.system.mapper.SysRoleMapper;
import com.coob.sjts.modules.system.mapper.SysUserRoleMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 角色(SysRole)表服务实现类
 *
 * @author wangqingli
 * @since 2024-05-30 14:42:48
 */
@Service("sysRoleService")
public class SysRoleService {
    @Resource
    private SysRoleMapper sysRoleMapper;
    @Resource
    private SysUserRoleMapper sysUserRoleMapper;

    /**
     * 新增数据
     *
     * @param sysRole 实例对象
     * @return 是否成功
     */
    public boolean insert(SysRole sysRole) {
        return this.sysRoleMapper.insert(sysRole);
    }


    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */

    public boolean deleteById(Long id) {
        return this.sysRoleMapper.deleteById(id);
    }

    /**
     * 修改数据
     *
     * @param sysRole 实例对象
     * @return 是否成功
     */

    public boolean update(SysRole sysRole) {
        return this.sysRoleMapper.update(sysRole);
    }


    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    public SysRole selectById(Long id) {
        return this.sysRoleMapper.selectById(id);
    }

    /**
     * 分页查询
     *
     * @param sysRole 筛选条件
     * @return 查询结果
     */
    public List<SysRole> selectByPage(SysRole sysRole) {
        return this.sysRoleMapper.selectList(sysRole);
    }


}
