package com.coob.sjts.modules.system.service;

import com.coob.sjts.modules.system.domain.SysUserRole;
import com.coob.sjts.modules.system.mapper.SysUserRoleMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * (SysUserRole)表服务实现类
 *
 * @author wangqingli
 * @since 2024-05-30 14:12:09
 */
@Service("sysUserRoleService")
public class SysUserRoleService {
    @Resource
    private SysUserRoleMapper sysUserRoleMapper;


    /**
     * 新增数据
     *
     * @param sysUserRole 实例对象
     * @return 影响行数
     */
    public boolean insert(SysUserRole sysUserRole) {
        return sysUserRoleMapper.insert(sysUserRole);
    }

    /**
     * 批量新增数据
     *
     * @param entities List<SysUserRole> 实例对象列表
     * @return 影响行数
     */
    public int insertBatch(List<SysUserRole> entities) {
        return sysUserRoleMapper.insertBatch(entities);
    }


    /**
     * @return
     */
    public boolean deleteByRoleId(Long roleId) {
        return sysUserRoleMapper.deleteByRoleId(roleId);
    }

    /**
     * @return
     */
    public boolean deleteByUserId(Long userId) {
        return sysUserRoleMapper.deleteByUserId(userId);
    }
}
