package com.coob.sjts.modules.system.service;

import com.coob.sjts.modules.system.domain.SysUser;
import com.coob.sjts.modules.system.mapper.SysUserMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * (SysUser)表服务实现类
 *
 * @author wangqingli
 * @since 2024-05-30 14:11:56
 */
@Service("sysUserService")
public class SysUserService {
    @Resource
    private SysUserMapper sysUserMapper;


    /**
     * 新增数据
     *
     * @param sysUser 实例对象
     * @return 实例对象
     */

    public boolean insert(SysUser sysUser) {
        return this.sysUserMapper.insert(sysUser);
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */

    public boolean deleteById(Integer id) {
        return this.sysUserMapper.deleteById(id);
    }

    /**
     * 修改数据
     *
     * @param sysUser 实例对象
     * @return 实例对象
     */

    public boolean update(SysUser sysUser) {
        return this.sysUserMapper.update(sysUser);
    }


    public boolean updateStatus(Integer id, Integer state) {
        SysUser sysUser = new SysUser();
        sysUser.setId(id);
        sysUser.setState(state);
        sysUser.setUpdateTime(new java.util.Date());
        return this.sysUserMapper.update(sysUser);
    }

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */

    public SysUser selectById(Integer id) {
        return this.sysUserMapper.selectById(id);
    }

    public SysUser selectByAccount(String account) {
        return sysUserMapper.selectByAccount(account);
    }
    
    /**
     * 分页查询
     *
     * @param sysUser 筛选条件
     * @return 查询结果
     */

    public List<SysUser> selectByPage(SysUser sysUser) {
        return this.sysUserMapper.selectList(sysUser);
    }



}
