package com.coob.sjts.modules.task;


import com.coob.sjts.modules.mis.bo.GrzfTjMjBo;
import com.coob.sjts.modules.mis.service.YsHtlsbMsrService;
import com.coob.sjts.modules.zhfg.domain.GrzfTj;
import com.coob.sjts.modules.zhfg.domain.GrzfTjMj;
import com.coob.sjts.modules.zhfg.domain.GrzfTjNl;
import com.coob.sjts.modules.zhfg.domain.GrzfTjQy;
import com.coob.sjts.modules.zhfg.service.GrzfTjService;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;


/**
 * 个人住房统计定时任务
 *
 * @author Awei
 * @since
 */
@Component
@EnableAsync
@EnableScheduling
public class GrzfTjTimeTask {

    @Resource
    private YsHtlsbMsrService ysHtlsbMsrService;
    @Resource
    private GrzfTjService grzfTjService;


    /**
     * 每天晚上10点30执行更新数据
     */
    @Scheduled(cron ="0 30 22 * * ?")
    @Async   //异步调用注解
    public void gfrzTjTimeTask() {

        System.out.println("个人住房统计定时任务启动！！！！！");

                            /*按房屋通用途统计购房数据*/
        grzfYtZz();
        System.out.println("个人住房统计   住宅用途统计信息更新完毕");
        grzfYtQb();
        System.out.println("个人住房统计   全部用途统计信息更新完毕");

        System.out.println("个人住房统计   面积信息更新完毕");
        grzfMj();
        System.out.println("个人住房统计   面积信息更新完毕");
                            /*按年龄统计购房数据*/
        grzfNl();
        System.out.println("个人住房年龄统计  更新结束");


                            /*按区域统计购房数据*/
        grzfQy();
        System.out.println("个人住房区域统计  更新结束");

        System.out.println("个人住房统计定时任务结束！！！！！");

    }



    /*****************************************************************/
                            /*按房屋用途统计*/

    /**
     * 住宅统计信息
     */
    private void grzfYtZz(){

        GrzfTj grzfTj1 = grzfTjService.selectByTsQjAndYt(1, 1, 1);
        GrzfTj tj1 = ysHtlsbMsrService.countGrzfTjByZz(1, 1).init();
        if(grzfTj1 == null){
            grzfTjService.insert(tj1);
        }else{
            tj1.setId(grzfTj1.getId());
            grzfTjService.update(tj1);
        }

        GrzfTj grzfTj2 = grzfTjService.selectByTsQjAndYt(2, 2, 1);
        GrzfTj tj2 = ysHtlsbMsrService.countGrzfTjByZz(2, 2).init();
        if(grzfTj2 == null){
            grzfTjService.insert(tj2);
        }else{
            tj2.setId(grzfTj2.getId());
            grzfTjService.update(tj2);
        }
        GrzfTj grzfTj3 = grzfTjService.selectByTsQjAndYt(3, 3, 1);
        GrzfTj tj3 = ysHtlsbMsrService.countGrzfTjByZz(3, 3).init();
        if(grzfTj3 == null){
            grzfTjService.insert(tj3);
        }else{
            tj3.setId(grzfTj3.getId());
            grzfTjService.update(tj3);
        }
        GrzfTj grzfTj4= grzfTjService.selectByTsQjAndYt(4, 4, 1);
        GrzfTj tj4 = ysHtlsbMsrService.countGrzfTjByZz(4, 4).init();
        if(grzfTj4 == null){
            grzfTjService.insert(tj4);
        }else{
            tj4.setId(grzfTj4.getId());
            grzfTjService.update(tj4);
        }

        GrzfTj grzfTj5 = grzfTjService.selectByTsQjAndYt(5, 5, 1);
        GrzfTj tj5 = ysHtlsbMsrService.countGrzfTjByZz(5, 5).init();
        if(grzfTj5 == null){
            grzfTjService.insert(tj5);
        }else{
            tj5.setId(grzfTj5.getId());
            grzfTjService.update(tj5);
        }

        GrzfTj grzfTj6 = grzfTjService.selectByTsQjAndYt(6, 10, 1);
        GrzfTj tj6 = ysHtlsbMsrService.countGrzfTjByZz(6, 10).init();
        if(grzfTj6 == null){
            grzfTjService.insert(tj6);
        }else{
            tj6.setId(grzfTj6.getId());
            grzfTjService.update(tj6);
        }

        GrzfTj grzfTj7 = grzfTjService.selectByTsQjAndYt(11, 20, 1);
        GrzfTj tj7 = ysHtlsbMsrService.countGrzfTjByZz(11, 20).init();
        if(grzfTj7 == null){
            grzfTjService.insert(tj7);
        }else{
            tj7.setId(grzfTj7.getId());
            grzfTjService.update(tj7);
        }

        GrzfTj grzfTj8 = grzfTjService.selectByTsQjAndYt(21, 0, 1);
        GrzfTj tj8 = ysHtlsbMsrService.countGrzfTjByZz(21, 0).init();
        if(grzfTj8 == null){
            grzfTjService.insert(tj8);
        }else{
            tj8.setId(grzfTj8.getId());
            grzfTjService.update(tj8);
        }
    }

    /**
     * 全部统计信息
     */
    private void grzfYtQb(){

        GrzfTj grzfTj1 = grzfTjService.selectByTsQjAndYt(1, 1, 0);
        GrzfTj tj1 = ysHtlsbMsrService.countGrzfTj(1, 1).init();
        if(grzfTj1 == null){
            grzfTjService.insert(tj1);
        }else{
            tj1.setId(grzfTj1.getId());
            grzfTjService.update(tj1);
        }

        GrzfTj grzfTj2 = grzfTjService.selectByTsQjAndYt(2, 2, 0);
        GrzfTj tj2 =  ysHtlsbMsrService.countGrzfTj(2, 2).init();
        if(grzfTj2 == null){
            grzfTjService.insert(tj2);
        }else{
            tj2.setId(grzfTj2.getId());
            grzfTjService.update(tj2);
        }
        GrzfTj grzfTj3 = grzfTjService.selectByTsQjAndYt(3, 3, 0);
        GrzfTj tj3 = ysHtlsbMsrService.countGrzfTj(3, 3).init();
        if(grzfTj3 == null){
            grzfTjService.insert(tj3);
        }else{
            tj3.setId(grzfTj3.getId());
            grzfTjService.update(tj3);
        }
        GrzfTj grzfTj4= grzfTjService.selectByTsQjAndYt(4, 4, 0);
        GrzfTj tj4 = ysHtlsbMsrService.countGrzfTj(4, 4).init();
        if(grzfTj4 == null){
            grzfTjService.insert(tj4);
        }else{
            tj4.setId(grzfTj4.getId());
            grzfTjService.update(tj4);
        }

        GrzfTj grzfTj5 = grzfTjService.selectByTsQjAndYt(5, 5, 0);
        GrzfTj tj5 = ysHtlsbMsrService.countGrzfTj(5, 5).init();
        if(grzfTj5 == null){
            grzfTjService.insert(tj5);
        }else{
            tj5.setId(grzfTj5.getId());
            grzfTjService.update(tj5);
        }

        GrzfTj grzfTj6 = grzfTjService.selectByTsQjAndYt(6, 10, 0);
        GrzfTj tj6 = ysHtlsbMsrService.countGrzfTj(6, 10).init();
        if(grzfTj6 == null){
            grzfTjService.insert(tj6);
        }else{
            tj6.setId(grzfTj6.getId());
            grzfTjService.update(tj6);
        }

        GrzfTj grzfTj7 = grzfTjService.selectByTsQjAndYt(11, 20, 0);
        GrzfTj tj7 = ysHtlsbMsrService.countGrzfTj(11, 20).init();
        if(grzfTj7 == null){
            grzfTjService.insert(tj7);
        }else{
            tj7.setId(grzfTj7.getId());
            grzfTjService.update(tj7);
        }

        GrzfTj grzfTj8 = grzfTjService.selectByTsQjAndYt(21, 0, 0);
        GrzfTj tj8 = ysHtlsbMsrService.countGrzfTj(21, 0).init();
        if(grzfTj8 == null){
            grzfTjService.insert(tj8);
        }else{
            tj8.setId(grzfTj8.getId());
            grzfTjService.update(tj8);
        }

    }

    /**
     * 按面积统计
     */
    private void grzfMj() {
        BigDecimal dec90 = new BigDecimal(90);
        BigDecimal dec180 = new BigDecimal(180);
        BigDecimal dec300 = new BigDecimal(300);
        BigDecimal dec500 = new BigDecimal(500);
        BigDecimal decf1 = new BigDecimal(-1);

        List<GrzfTjMj> list = new ArrayList<>();
        // 90 90-180 180-300 300-500 500+
        GrzfTjMjBo grzfTjMjBo = ysHtlsbMsrService.countGrzfTjMj();
        if (grzfTjMjBo != null) {
            GrzfTjMj mj = new GrzfTjMj(0,BigDecimal.ZERO,dec90,grzfTjMjBo.getRslt90());
            GrzfTjMj mj90 = new GrzfTjMj(0,dec90,dec180,grzfTjMjBo.getRs180());
            GrzfTjMj mj180 = new GrzfTjMj(0,dec180,dec300,grzfTjMjBo.getRs300());
            GrzfTjMj mj300 = new GrzfTjMj(0,dec300,dec500,grzfTjMjBo.getRs500());
            GrzfTjMj mj500 = new GrzfTjMj(0,dec500,decf1,grzfTjMjBo.getRslg500());
            list.add(mj);
            list.add(mj90);
            list.add(mj180);
            list.add(mj300);
            list.add(mj500);
        }
        GrzfTjMjBo grzfTjMjBozz = ysHtlsbMsrService.countGrzfTjZzMj();
        if (grzfTjMjBozz != null) {
            GrzfTjMj mj = new GrzfTjMj(0,BigDecimal.ZERO,dec90,grzfTjMjBozz.getRslt90());
            GrzfTjMj mj90 = new GrzfTjMj(0,dec90,dec180,grzfTjMjBozz.getRs180());
            GrzfTjMj mj180 = new GrzfTjMj(0,dec180,dec300,grzfTjMjBozz.getRs300());
            GrzfTjMj mj300 = new GrzfTjMj(0,dec300,dec500,grzfTjMjBozz.getRs500());
            GrzfTjMj mj500 = new GrzfTjMj(0,dec500,decf1,grzfTjMjBozz.getRslg500());
            list.add(mj);
            list.add(mj90);
            list.add(mj180);
            list.add(mj300);
            list.add(mj500);
        }
        if (!CollectionUtils.isEmpty(list)) {
            grzfTjService.insertOrUpdateBatch(list);
        }
    }

    /*****************************************************************/
                            /*按年龄统计购房信息*/


    private void grzfNl(){

        //查询并更新20岁以下的购房统计数量，不包含20岁
        GrzfTjNl grzfTjNl1 = grzfTjService.selectByNl(0, 20);
        GrzfTjNl nl1 = ysHtlsbMsrService.countGrzfTjNl(0, 20).init();
        if(grzfTjNl1 == null){
            grzfTjService.insertNl(nl1);
        }else{
            nl1.setId(grzfTjNl1.getId());
            grzfTjService.updateNl(nl1);
        }

        //查询并更新20岁-29岁的购房统计数量
        GrzfTjNl grzfTjNl2 = grzfTjService.selectByNl(20, 30);
        GrzfTjNl nl2 = ysHtlsbMsrService.countGrzfTjNl(20, 30).init();
        if(grzfTjNl1 == null){
            grzfTjService.insertNl(nl2);
        }else{
            nl2.setId(grzfTjNl2.getId());
            grzfTjService.updateNl(nl2);
        }

        //查询并更新30岁-39岁的购房统计数量
        GrzfTjNl grzfTjNl3 = grzfTjService.selectByNl(30, 40);
        GrzfTjNl nl3 = ysHtlsbMsrService.countGrzfTjNl(30, 40).init();
        if(grzfTjNl3 == null){
            grzfTjService.insertNl(nl3);
        }else{
            nl3.setId(grzfTjNl3.getId());
            grzfTjService.updateNl(nl3);
        }

        //查询并更新40岁-49岁的购房统计数量
        GrzfTjNl grzfTjNl4 = grzfTjService.selectByNl(40, 50);
        GrzfTjNl nl4 = ysHtlsbMsrService.countGrzfTjNl(40, 50).init();
        if(grzfTjNl4 == null){
            grzfTjService.insertNl(nl4);
        }else{
            nl4.setId(grzfTjNl4.getId());
            grzfTjService.updateNl(nl4);
        }

        //查询并更新50岁以上的购房统计数量
        GrzfTjNl grzfTjNl5 = grzfTjService.selectByNl(50, 0);
        GrzfTjNl nl5 = ysHtlsbMsrService.countGrzfTjNl(50, 0).init();
        if(grzfTjNl5 == null){
            grzfTjService.insertNl(nl5);
        }else{
            nl5.setId(grzfTjNl5.getId());
            grzfTjService.updateNl(nl5);
        }

    }

    /*****************************************************************/
                            /*按区域统计购房信息*/


    private void grzfQy(){

        //查询并更新寿光本地的购房人数和占比
        GrzfTjQy grzfTjQy1 = grzfTjService.selectByQy(1);
        GrzfTjQy qy1 = ysHtlsbMsrService.countGrzfTjByQy(1).init();
        if(grzfTjQy1 == null){
            grzfTjService.insertQy(qy1);
        }else{
            qy1.setId(grzfTjQy1.getId());
            grzfTjService.updateQy(qy1);
        }

        //查询并更新潍坊市（但不是寿光本地的）在寿光的购房人数和占比
        GrzfTjQy grzfTjQy2 = grzfTjService.selectByQy(2);
        GrzfTjQy qy2 = ysHtlsbMsrService.countGrzfTjByQy(2).init();
        if(grzfTjQy2 == null){
            grzfTjService.insertQy(qy2);
        }else{
            qy2.setId(grzfTjQy2.getId());
            grzfTjService.updateQy(qy2);
        }

        //查询并更新山东省（但不是潍坊的）在寿光的购房人数和占比
        GrzfTjQy grzfTjQy3 = grzfTjService.selectByQy(3);
        GrzfTjQy qy3 = ysHtlsbMsrService.countGrzfTjByQy(3).init();
        if(grzfTjQy3 == null){
            grzfTjService.insertQy(qy3);
        }else{
            qy3.setId(grzfTjQy3.getId());
            grzfTjService.updateQy(qy3);
        }

        //查询并更新其他区域（不是山东省内的）在寿光的购房人数和占比
        GrzfTjQy grzfTjQy4 = grzfTjService.selectByQy(4);
        GrzfTjQy qy4 = ysHtlsbMsrService.countGrzfTjByQy(4).init();
        if(grzfTjQy4 == null){
            grzfTjService.insertQy(qy4);
        }else{
            qy4.setId(grzfTjQy4.getId());
            grzfTjService.updateQy(qy4);
        }



    }







}
