package com.coob.sjts.modules.task;


import com.coob.sjts.api.stSjts.StDataService;
import com.coob.sjts.modules.mis.service.sjts.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;


/**
 * 省厅数据推送定时任务
 *
 * @author Awei
 * @since
 */
@Component
@EnableAsync
@EnableScheduling
public class StSjtsTimeTask {

    @Autowired
    private StDataService stDataService;
    @Autowired
    private SjtsStJglzService sjtsStJglzService;
    @Autowired
    private SjtsStFwwqbaService fwwqbaService;
    @Autowired
    private SjtsStJgzhmxService jgzhmxService;
    @Autowired
    private SjtsStYsxkzService ysxkzService;
    @Autowired
    private SjtsStXmxxService xmxxService;
    @Autowired
    private SjtsStWqbaService wqBaService;

    /**
     * 每天12点执行省厅数据采集
     */
    @Scheduled(cron ="0 0 12 * * ?")
    @Async   //异步调用注解
    public void StSjcjTimeTask() {

        System.out.println("省厅推送数据采集定时任务启动！！！！！");
        //更新监管楼幢信息
         sjtsStJglzService.impJglz();
        System.out.println("省厅 监管楼幢数据更新完成");

        //更新项目信息表的推送信息
        xmxxService.impXmxx();
        System.out.println("省厅推送项目信息采集完成");

        //更新预售许可证表的推送信息
        ysxkzService.impYsxkz();
        System.out.println("省厅推送预售许可证信息采集完成");

        //更新监管账户表的推送信息
        jgzhmxService.imptJgzhmx();
        System.out.println("省厅推送监管账户明细信息采集完成");

        //更新网签备案的推送信息
        wqBaService.impWqba();
        System.out.println("省厅推送网签备案信息采集完成");

        //更新房屋网签备案的推送信息
        fwwqbaService.impFwwqBa();
        System.out.println("省厅推送房屋网签备案完成");

        System.out.println("省厅推送数据采集完成");

        System.out.println("省厅推送数据采集定时任务结束！！！！！");
    }


    /**
     * 每天15点执行数据推送
     */
    @Scheduled(cron ="0 0 15 * * ?")
    @Async   //异步调用注解
    public void StSjtsTimeTask() throws Exception {

        System.out.println("省厅推送数据定时任务启动！！！！！");


        stDataService.sendData();//推送项目信息、预售许可证信息、监管账户信息、网签备案信息
        System.out.println("省厅数据已推送");
        stDataService.sendDataFwWq();//推送房屋网签备案信息
        System.out.println("省厅房屋网签备案数据数据已推送");

        System.out.println("省厅推送数据定时任务结束！！！！！");
    }








}
