package com.coob.sjts.modules.task;


import com.coob.sjts.modules.kfxy.domain.KfsXwjl;
import com.coob.sjts.modules.kfxy.service.KfsXwjlService;
import com.coob.sjts.modules.mis.domain.wk.*;
import com.coob.sjts.modules.mis.service.wk.*;
import com.coob.sjts.modules.wkzjk.domain.GxGxbs;
import com.coob.sjts.modules.wkzjk.service.GxGxbsService;
import com.coob.sjts.modules.wkzjk.service.InsertGxService;
import com.coob.sjts.modules.zhfg.domain.wk.SgKfjdyj;
import com.coob.sjts.modules.zhfg.domain.wk.SgYskyj;
import com.coob.sjts.modules.zhfg.domain.wk.XmXmsc;
import com.coob.sjts.modules.zhfg.service.wk.WkSgKfjdyjService;
import com.coob.sjts.modules.zhfg.service.wk.WkSgYskyjService;
import com.coob.sjts.modules.zhfg.service.wk.WkXmXmscService;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;


/**
 * 省厅数据推送定时任务
 *
 * @author Awei
 * @since
 */
@Component
@EnableAsync
@EnableScheduling
public class WkZjkTimeTask {

    //土地证
    @Resource
    private YsXmtdService ysXmtdService;
    //用地证
    @Resource
    private YsXmydService ysXmydService;
    //工程证
    @Resource
    private YsXmgcService ysXmgcService;
    //施工证
    @Resource
    private YsXmsgService ysXmsgService;
    //项目信息
    @Resource
    private YsXmxxService ysXmxxService;
    //项目手册  项目补充
    @Resource
    private WkXmXmscService xmXmscService;
    //企业信息
    @Resource
    private YsQyxxbService ysQyxxbService;
    //企业资质
    @Resource
    private YsQyzzqkService ysQyzzqkService;
    //开放商信用
    @Resource
    private KfsXwjlService kfsXwjlService;
    //预收款预警
    @Resource
    private WkSgYskyjService sgYskyjService;
    //开发进度预警
    @Resource
    private WkSgKfjdyjService sgKfjdyjService;
    //已更新数据的id标识
    @Resource
    private GxGxbsService gxGxbsService;
    //给共享库插入数据
    @Resource
    private InsertGxService insertGxService;
    //用户信息
    @Resource
    private SyUserService userService;
    //部门信息
    @Resource
    private SyDepartService sgDepartService;


    /**
     * 每天0点执行更新数据
     */
    @Scheduled(cron ="0 0 0 * * ?")
    @Async   //异步调用注解
    public void TimeTask() {

        System.out.println("推送数据定时任务启动！！！！！");

        //查询推送数据的最后id
        GxGxbs gxGxbs = gxGxbsService.selectBs();

        //更新企业信息
        List<YsQyxxb> qyList = ysQyxxbService.selectByOldId(gxGxbs.getQyid());
        if(qyList!=null && qyList.size()>0){
            insertGxService.saveQyxx(qyList);
        }

        //更新资质信息
        List<YsQyzzqk> zzList = ysQyzzqkService.selectByOldId(gxGxbs.getQyzzid());
        if(zzList!=null && zzList.size()>0){
            insertGxService.saveQyzz(zzList);
        }

        //更新信用信息
        List<KfsXwjl> xyList = kfsXwjlService.selectByOldId(gxGxbs.getQyxyid());
        if(xyList!=null && xyList.size()>0){
            insertGxService.saveQyxy(xyList);
        }

        //更新项目信息
        List<YsXmxx> xmList = ysXmxxService.selectByOldId(gxGxbs.getXmxxid());
        if(xmList!=null && xmList.size()>0){
            insertGxService.saveXmxx(xmList);
        }

        //更新土地证信息
        List<YsXmtd> tdzList = ysXmtdService.selectByOldId(gxGxbs.getTdzid());
        if(tdzList!=null && tdzList.size()>0){
            insertGxService.saveTdz(tdzList);
        }

        //更新用地证信息
        List<YsXmyd> ydzList = ysXmydService.selectByOldId(gxGxbs.getYdzid());
        if(ydzList!=null && ydzList.size()>0){
            insertGxService.saveYdz(ydzList);
        }

        //更新工程证信息
        List<YsXmgc> gcList = ysXmgcService.selectByOldId(gxGxbs.getGczid());
        if(gcList!=null && gcList.size()>0){
            insertGxService.saveGcz(gcList);
        }

        //更新施工证信息
        List<YsXmsg> sgzList = ysXmsgService.selectByOldId(gxGxbs.getSgzid());
        if(sgzList!=null && sgzList.size()>0){
            insertGxService.saveSgz(sgzList);
        }

        //更新项目补充信息
        List<XmXmsc> bcList = xmXmscService.selectAllList();
        insertGxService.deleteXmbc();
        insertGxService.saveXmbc(bcList);

        //更新项目预收款预警信息
        this.savesk();

        //更新开发商进度预警信息
        this.saveKfjdyj();

        //保存用户信息---主管部门以及开发企业用户
        List<SgUser> qyUser = userService.selectQyUser();
        List<SgUser> zgbm = userService.selectZgUser();
        ArrayList<SgUser> user = new ArrayList<>(zgbm);
        user.addAll(qyUser);
        Integer sl = gxGxbsService.countUsers();//统计中间库中的用户数量

        if(sl != user.size()){
            insertGxService.deleteUser();
            insertGxService.saveUser(user);
        }
        List<SgDepart> depts = sgDepartService.selectAll();
        Integer deptSl = gxGxbsService.countDept();
        if(deptSl != depts.size()){
            insertGxService.deleteDept();
            insertGxService.saveDept(depts);
        }


        //统计更新完后推送数据的最后的id  并且更新到gx_gxbs表中进行记录
        GxGxbs _gxGxbs = gxGxbsService.countBs();
        _gxGxbs.setDeptid(depts.size());
        gxGxbsService.updateBs(_gxGxbs);

        System.out.println("推送数据定时任务结束！！！！！");


    }

    /**
     * 更新预收款预警信息
     */
    public void savesk(){

        //删除预收款预警信息
        insertGxService.deleteYskyj();

        //保存预收款预警项目
        List<SgYskyj> sgYskyjs = sgYskyjService.selectHtQy();
        insertGxService.saveYskYj(sgYskyjs);

        //更新公积金4个月未缴存合同数量预警
        List<SgYskyj> gjj1 = sgYskyjService.selectCountGjjYj1();
        if (gjj1 != null && gjj1.size() > 0) {
            for (SgYskyj sgYskyj : gjj1) {
                insertGxService.updateYskYj(sgYskyj);
            }
        }

        //更新公积金5个月未缴存合同数量预警
        List<SgYskyj> gjj2 = sgYskyjService.selectCountGjjYj2();
        if (gjj2 != null && gjj2.size() > 0) {
            for (SgYskyj sgYskyj : gjj2) {
                insertGxService.updateYskYj(sgYskyj);
            }
        }

        //更新商业贷5个月未缴存合同数量预警
        List<SgYskyj> sy1 = sgYskyjService.selectCountSydkYj1();
        if (sy1 != null && sy1.size() > 0) {
            for (SgYskyj sgYskyj : sy1) {
                insertGxService.updateYskYj(sgYskyj);
            }
        }

        //更新商业贷6个月未缴存合同数量预警
        List<SgYskyj> sy2 = sgYskyjService.selectCountSydkYj2();
        if (sy2 != null && sy2.size() > 0) {
            for (SgYskyj sgYskyj : sy2) {
                insertGxService.updateYskYj(sgYskyj);
            }
        }

        //更新首付款1个月未缴存合同数量预警
        List<SgYskyj> sfk1 = sgYskyjService.selectCountSfkYj1();
        if (sfk1 != null && sfk1.size() > 0) {
            for (SgYskyj sgYskyj : sfk1) {
                insertGxService.updateYskYj(sgYskyj);
            }
        }

        //更新首付款2个月未缴存合同数量预警
        List<SgYskyj> sfk2 = sgYskyjService.selectCountSfkYj2();
        if (sfk2 != null && sfk2.size() > 0) {
            for (SgYskyj sgYskyj : sfk2) {
                insertGxService.updateYskYj(sgYskyj);
            }
        }
    }


    /**
     * 更新开发进度预警
     */
    public void saveKfjdyj(){

        //删除原有的预警信息
        insertGxService.deleteKfjdyj();

        //查询所有在建在售的项目
        List<SgKfjdyj> list = sgKfjdyjService.selectXm();
        insertGxService.saveKfJdYj(list);


        //查询两个月得项目的投资月报
        List<SgKfjdyj> tz2 = sgKfjdyjService.selectTzByYd(2);
        for (SgKfjdyj sgKfjdyj : tz2) {
            sgKfjdyj.setTzqkYj1(0);
            insertGxService.updateKfJdYj(sgKfjdyj);
        }

        //查询3个月内项目的投资月报
        List<SgKfjdyj> tz3 = sgKfjdyjService.selectTzByYd(3);
        for (SgKfjdyj sgKfjdyj : tz3) {
            sgKfjdyj.setTzqkYj2(0);
            insertGxService.updateKfJdYj(sgKfjdyj);
        }

        //查询2个月内项目的销售月报
        List<SgKfjdyj> xs2 = sgKfjdyjService.selectXsByYd(2);
        for (SgKfjdyj sgKfjdyj : xs2) {
            sgKfjdyj.setXsqkYj1(0);
            insertGxService.updateKfJdYj(sgKfjdyj);
        }

        //查询3个月内项目的销售月报
        List<SgKfjdyj> xs3 = sgKfjdyjService.selectXsByYd(3);
        for (SgKfjdyj sgKfjdyj : xs3) {
            sgKfjdyj.setXsqkYj2(0);
            insertGxService.updateKfJdYj(sgKfjdyj);
        }

        //查询2个月内项目的建设进度月报
        List<SgKfjdyj> tg2 = sgKfjdyjService.selectTgByYd(2);
        for (SgKfjdyj sgKfjdyj : tg2) {
            sgKfjdyj.setJsjdYj1(0);
            insertGxService.updateKfJdYj(sgKfjdyj);
        }

        //查询3个月内项目的建设进度月报
        List<SgKfjdyj> tg3 = sgKfjdyjService.selectTgByYd(3);
        for (SgKfjdyj sgKfjdyj : tg3) {
            sgKfjdyj.setJsjdYj2(0);
            insertGxService.updateKfJdYj(sgKfjdyj);
        }


    }






}
