package com.coob.sjts.modules.task;


import com.coob.sjts.modules.zhfg.service.zjt.ZjtSpfTjService;
import com.coob.sjts.modules.zhfg.service.zjt.ZjtSpfXiaoshouTjService;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;


/**
 * 省厅数据推送定时任务
 *
 * @author Awei
 * @since
 */
@Component
@EnableAsync
@EnableScheduling
public class ZjtTjTimeTask {

    @Resource
    private ZjtSpfTjService zjtSpfService;
    @Resource
    private ZjtSpfXiaoshouTjService zjtSpfXiaoshouTjService;



    /**
     * 每小时的第40分钟执行更新数据
     */
    @Scheduled(cron ="0 40 * * * ?")
    @Async   //异步调用注解
    public void TimeTask() {


        //月报信息添加
        zjtSpfXiaoshouTjService.saveYb();
        //年报信息添加
        zjtSpfXiaoshouTjService.saveNb();

        //统计所有月报数据。更新zjt_spf_tj表数据
        zjtSpfService.saveTj();


    }






}
