package com.coob.sjts.modules.wkzjk.mapper;


import com.coob.sjts.modules.kfxy.domain.KfsXwjl;
import com.coob.sjts.modules.mis.domain.wk.*;
import com.coob.sjts.modules.zhfg.domain.wk.SgKfjdyj;
import com.coob.sjts.modules.zhfg.domain.wk.SgYskyj;
import com.coob.sjts.modules.zhfg.domain.wk.XmXmsc;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 将查询出来的数据添加到表中
 *
 * @author Awei
 * @createDate 2023-11-15 14:48:10
 */
@Mapper
public interface InsertMapper  {

    /**
     * 批量保存企业信息
     * @param list
     * @return
     */
    int saveQyxx(List<YsQyxxb> list);

    /**
     * 批量保存企业资质
     * @param list
     * @return
     */
    int saveQyzz(List<YsQyzzqk> list);

    /**
     * 批量保存企业信用
     * @param list
     * @return
     */
    int saveQyxy(List<KfsXwjl> list);

    /**
     * 批量保存项目信息
     * @param list
     * @return
     */
    int saveXmxx(List<YsXmxx> list);

    /**
     * 批量保存项目补充信息
     * @param list
     * @return
     */
    int saveXmbc(List<XmXmsc> list);

    /**
     * 批量保存土地证
     * @param list
     * @return
     */
    int saveTdz(List<YsXmtd> list);

    /**
     * 批量保存用地证
     * @param list
     * @return
     */
    int saveYdz(List<YsXmyd> list);

    /**
     * 批量保存工程证
     * @param list
     * @return
     */
    int saveGcz(List<YsXmgc> list);

    /**
     * 批量保存施工许可证
     * @param list
     * @return
     */
    int saveSgz(List<YsXmsg> list);

    /**
     * 批量保存收款预警信息
     * @param list
     * @return
     */
    int saveYskYj(List<SgYskyj> list);

    /**
     * 更新收款预警信息
     * @param sgYskyj
     * @return
     */
    int updateYskYj(SgYskyj sgYskyj);

    /**
     * 批量保存开放商进度预警
     * @param list
     * @return
     */
    int saveKfJdYj(List<SgKfjdyj> list);

    /**
     * 保存在建在售项目
     * @param list
     * @return
     */
    int saveKfjdys(List<SgKfjdyj> list);

    /**
     * 批量新增用户数据（MyBatis原生foreach方法）
     *
     * @param list List<SgUser> 实例对象列表
     * @return 影响行数
     */
    int saveUser(List<SgUser> list);

    /**
     * 更新在建在售项目进度预警
     * @param sgKfjdyj
     * @return
     */
    int updateKfjdyj(SgKfjdyj sgKfjdyj);

    /**
     * 批量新增部门数据
     *
     * @param list List<SgDepart> 实例对象列表
     * @return 影响行数
     */
    int saveDept( List<SgDepart> list);

    /**
     * 清除项目补充信息表的数据
     * @return
     */
    int deleteXmbc();

    /**
     * 清除收款预警信息表的数据
     * @return
     */
    int deleteYskyj();

    /**
     * 清除在建在售项目表的数据
     * @return
     */
    int deleteKfjdyj();

    /**
     * 清楚所有用户信息，重新添加
     * @return
     */
    int deleteUser();

    /**
     * 清除所有的部门信息
     * @return
     */
    int deleteDept();



}