package com.coob.sjts.modules.wkzjk.service;

import com.coob.sjts.modules.kfxy.domain.KfsXwjl;
import com.coob.sjts.modules.mis.domain.wk.*;
import com.coob.sjts.modules.wkzjk.mapper.InsertMapper;
import com.coob.sjts.modules.zhfg.domain.wk.SgKfjdyj;
import com.coob.sjts.modules.zhfg.domain.wk.SgYskyj;
import com.coob.sjts.modules.zhfg.domain.wk.XmXmsc;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;


/**
 * 更新数据服务实现类
 *
 * @author Awei
 * @since 2023-11-16 14:21:07
 */
@Service
public class InsertGxService {

    //中间库更新mapper
    @Resource
    private InsertMapper insertMapper;


    /**
     * 更新企业信息
     * @param list
     * @return
     */
    public int saveQyxx(List<YsQyxxb> list) {
        return insertMapper.saveQyxx(list);
    }

    /**
     * 更新企业资质信息
     * @param list
     * @return
     */
    public int saveQyzz(List<YsQyzzqk> list) {
        return insertMapper.saveQyzz(list);
    }

    /**
     * 更新企业信用信息
     * @param list
     * @return
     */
    public int saveQyxy(List<KfsXwjl> list) {
        return insertMapper.saveQyxy(list);
    }

    /**
     * 更新项目信息
     * @param list
     * @return
     */
    public int saveXmxx(List<YsXmxx> list) {
        return insertMapper.saveXmxx(list);
    }

    /**
     * 更新项目补充信息
     * @param list
     * @return
     */
    public int saveXmbc(List<XmXmsc> list) {
        return insertMapper.saveXmbc(list);
    }

    /**
     * 更新土地证信息
     * @param list
     * @return
     */
    public int saveTdz(List<YsXmtd> list) {
        return insertMapper.saveTdz(list);
    }

    /**
     * 更新用地证信息
     * @param list
     * @return
     */
    public int saveYdz(List<YsXmyd> list) {
        return insertMapper.saveYdz(list);
    }

    /**
     * 更新工程证信息
     * @param list
     * @return
     */
    public int saveGcz(List<YsXmgc> list) {
        return insertMapper.saveGcz(list);
    }

    /**
     * 更新施工许可证信息
     * @param list
     * @return
     */
    public int saveSgz(List<YsXmsg> list) {
        return insertMapper.saveSgz(list);
    }


    /**
     * 保存预收款项目信息
     * @param list
     */
    public void saveYskYj(List<SgYskyj> list) {
        insertMapper.saveYskYj(list);
    }

    /**
     * 更新预收款项目信息
     * @param sgYskyj
     * @return
     */
    public int updateYskYj(SgYskyj sgYskyj){
        return insertMapper.updateYskYj(sgYskyj);
    }

    /**
     * 保存在建在售项目信息
     * @param list
     * @return
     */
    public int saveKfJdYj(List<SgKfjdyj> list) {
        return insertMapper.saveKfJdYj(list);
    }

    /**
     * 更新在建在售项目信息
     * @param kfjdyj
     * @return
     */
    public int updateKfJdYj(SgKfjdyj kfjdyj){
        return insertMapper.updateKfjdyj(kfjdyj);
    }

    public Integer saveUser(List<SgUser> list){
        return insertMapper.saveUser(list);
    }

    public Integer saveDept(List<SgDepart> list){
        return this.insertMapper.saveDept(list);
    }

    /**
     * 删除项目补充信息
     * @return
     */
    public Integer deleteXmbc() {
        return this.insertMapper.deleteXmbc();
    }

    /**
     * 删除预收款项目信息
     * @return
     */
    public Integer deleteYskyj() {
        return this.insertMapper.deleteYskyj();
    }

    /**
     * 删除在建在售项目信息
     * @return
     */
    public Integer deleteKfjdyj() {
        return this.insertMapper.deleteKfjdyj();
    }

    /**
     * 删除所有用户信息
     * @return
     */
    public Integer deleteUser(){
        return this.insertMapper.deleteUser();
    }

    public Integer deleteDept(){
        return this.insertMapper.deleteDept();
    }


}
