package com.coob.sjts.modules.zhfg.bo;


import com.coob.sjts.common.utils.DateUtil;
import com.coob.sjts.modules.mis.domain.sjts.SjtsStJglz;
import com.coob.sjts.modules.mis.domain.sjts.SjtsStJgzhmx;
import com.coob.sjts.modules.mis.domain.sjts.SjtsZjbJglz;
import com.coob.sjts.modules.mis.domain.sjts.SjtsZjbJgzhmx;

import java.io.Serializable;
import java.math.BigDecimal;


/**
 * 监管、托管账户信息
 *  用于：查询托管、监管账户，插入到数据推送表
 */
public class ProjectAccBo implements Serializable {
    private static final long serialVersionUID = -1L;

    private Integer zhid;       //账户id，生成序号
    private String xmbh;        //项目编号
    private String xmmc;        //项目名称
    private String yhdm;        //银行代码
    private String yhmc;        //银行名称
    private String zh;          //账号
    private BigDecimal zhye;    //账户余额
    private BigDecimal jged;    //监管额度（协议额度）
    private String xybh;        //协议编号，托管账户使用该编号
    private String ywbh;        //业务编号，监管账户先试用该编号，如果该编号没值，使用xybh


    /**
     * 针对监管账户，设置协议编号
     */
    public void resetJgyxbh(){
        if(this.ywbh != null && this.ywbh.length() > 8 ) {
            this.xybh = ywbh;
        }
    }


    public SjtsStJgzhmx createJgzhmx(SjtsStJglz lz) {
        String curT = DateUtil.getCurDateStr("yyyyMMddHHmmss");

        SjtsStJgzhmx mx = new SjtsStJgzhmx();

        mx.setXh(this.zhid.toString());
        mx.setXmbs(this.xmbh);
        mx.setJgbz(lz.getXmjgbz());
        mx.setYlcbl(lz.getXmlcbl());
        mx.setXmmc(this.xmmc);
        mx.setXmbh(this.xmbh);
        mx.setJgyhdm(this.yhdm);
        mx.setJgyhmc(this.yhmc);
        mx.setJgzh(this.zh);
        mx.setJgxybh(this.xybh);
        mx.setJgxyed(this.jged);
        mx.setJgzhye(this.zhye);
        mx.setXzqhdm("370783");
        mx.setXzqhmc("寿光市");
        mx.setCityno("370700");
        mx.setCityname("潍坊市");
        mx.setSjscsj(curT);
        mx.setSjgxsj(curT);
        mx.setTszt(1);
        mx.setTssj("");

        return mx;
    }


    public SjtsZjbJgzhmx createJgzhmx(SjtsZjbJglz lz) {
        String curT = DateUtil.getCurDateStr("yyyyMMddHHmmss");

        SjtsZjbJgzhmx mx = new SjtsZjbJgzhmx();

        mx.setXh(this.zhid.toString());
        mx.setXmmc(this.xmmc);
        mx.setXmbh(this.xmbh);
        mx.setJgyhdm(this.yhdm);
        mx.setJgyhmc(this.yhmc);
        mx.setJgzh(this.zh);
        mx.setJgxybh(this.xybh);
        mx.setJgxyed(this.jged);
        mx.setJgzhye(this.zhye);
        mx.setXzqhdm("370783");
        mx.setXzqhmc("寿光市");
        mx.setCityno("370700");
        mx.setCityname("潍坊市");
        mx.setSjscsj(curT);
        mx.setSjgxsj(curT);
        mx.setTszt(1);
        mx.setTssj("");

        return mx;
    }


    public Integer getZhid() {
        return zhid;
    }

    public void setZhid(Integer zhid) {
        this.zhid = zhid;
    }

    public String getXmbh() {
        return xmbh;
    }

    public void setXmbh(String xmbh) {
        this.xmbh = xmbh;
    }

    public String getXmmc() {
        return xmmc;
    }

    public void setXmmc(String xmmc) {
        this.xmmc = xmmc;
    }

    public String getYhdm() {
        return yhdm;
    }

    public void setYhdm(String yhdm) {
        this.yhdm = yhdm;
    }

    public String getYhmc() {
        return yhmc;
    }

    public void setYhmc(String yhmc) {
        this.yhmc = yhmc;
    }

    public String getZh() {
        return zh;
    }

    public void setZh(String zh) {
        this.zh = zh;
    }

    public BigDecimal getZhye() {
        return zhye;
    }

    public void setZhye(BigDecimal zhye) {
        this.zhye = zhye;
    }

    public BigDecimal getJged() {
        return jged;
    }

    public void setJged(BigDecimal jged) {
        this.jged = jged;
    }

    public String getXybh() {
        return xybh;
    }

    public void setXybh(String xybh) {
        this.xybh = xybh;
    }

    public String getYwbh() {
        return ywbh;
    }

    public void setYwbh(String ywbh) {
        this.ywbh = ywbh;
    }
}
