package com.coob.sjts.modules.zhfg.domain.zjt;

import com.coob.sjts.common.tool.DateUtil;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.io.Serializable;

/**
 * (ZjtSpfXiaoshouTj)实体类
 *
 * @author makejava
 * @since 2024-06-12 09:49:09
 */
@Data
public class ZjtSpfXiaoshouTj implements Serializable {
    private static final long serialVersionUID = -23452564815121511L;

    private Integer id;
    private String nd;          //年度
    private String yd;          //月度   如果是年度数据是月度值为0
    private Integer psts;       //批售套数
    private BigDecimal psmj;    //批售面积
    private Integer pszzts;     //批售住宅套数
    private BigDecimal pszzmj;  //批售住宅面积
    private Integer xsts;       //销售总套数
    private BigDecimal xsmj;    //销售总面积
    private BigDecimal xsje;    //销售总金额
    private Integer xszzts;     //销售住宅套数
    private BigDecimal xszzmj;  //销售住宅面积
    private BigDecimal xszzje;  //销售住宅金额
    private BigDecimal xszzjj;  //销售住宅均价
    private Integer kcts;       //库存套数
    private BigDecimal kcmj;    //库存面积
    private Integer kczzts;     //库存住宅套数
    private BigDecimal kczzmj;  //库存住宅面积
    private Integer state;      //数据状态
    private String tssj;        //推送时间 yyyy-MM-dd  HH:mm:ss
    private Date ybDate;        //年度-月度-日期 年度只有年 月度是年月

    public ZjtSpfXiaoshouTj() {
    }


    //如果没有该月度和年度的销售月报信息  则初始化一个空的  bs = 0  初始化年度数据  bs = 1  初始化月度数据
    public ZjtSpfXiaoshouTj createXiaoshouTj(int bs) {
        ZjtSpfXiaoshouTj xs = new ZjtSpfXiaoshouTj();
        xs.setNd(String.valueOf(DateUtil.getCurYear()));  //设置当前年
        if (bs == 0) {
            xs.setYd("0"); //如果插入的是年度数据则设置月度值为0
            xs.setYbDate(DateUtil.curDate("yyyy"));
        } else {
            xs.setYd(ydformat0yd(DateUtil.getCurMonth())); //设置当前月
            xs.setYbDate(DateUtil.curDate("yyyy-MM"));
        }
        xs.setPsts(0);
        xs.setPsmj(new BigDecimal(0));
        xs.setPszzts(0);
        xs.setPszzmj(new BigDecimal(0));
        xs.setXsts(0);
        xs.setXsmj(new BigDecimal(0));
        xs.setXsje(new BigDecimal(0));
        xs.setXszzts(0);
        xs.setXszzmj(new BigDecimal(0));
        xs.setXszzje(new BigDecimal(0));
        xs.setXszzjj(new BigDecimal(0));
        xs.setKcts(0);
        xs.setKcmj(new BigDecimal(0));
        xs.setKczzts(0);
        xs.setKczzmj(new BigDecimal(0));
        xs.setState(1);

        return xs;
    }

    /**
     * 本月库存信息初始化
     *
     * @param lsyb
     */
    public void setInitYdKc(ZjtSpfXiaoshouTj lsyb) {
        this.setKcts(lsyb.getKcts());
        this.setKcmj(lsyb.getKcmj());
        this.setKczzts(lsyb.getKczzts());
        this.setKczzmj(lsyb.getKczzmj());
    }

    /**
     * 本月销售信息统计赋值
     */
    public void setByydxs(ZjtSpfXiaoshouTj byyb) {
        this.psts = byyb.getPsts();
        this.psmj = byyb.getPsmj();
        this.pszzts = byyb.getPszzts();
        this.pszzmj = byyb.getPszzmj();
        this.xsts = byyb.getXsts();
        this.xsmj = byyb.getXsmj();
        this.xsje = byyb.getXsje();
        this.xszzts = byyb.getXszzts();
        this.xszzmj = byyb.getXszzmj();
        this.xszzje = byyb.getXszzje();
        this.xszzjj = byyb.getXszzjj();
    }

    /**
     * 月份前加0
     * @param yd
     * @return
     */
    private String ydformat0yd(Integer yd){
        if(yd < 10){
            return  "0"+ yd;
        }
        return String.valueOf(yd);
    }
}

