package com.coob.sjts.modules.zhfg.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.zhfg.domain.GrzfTj;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.transaction.annotation.Transactional;


/**
 * 个人住房统计 根据房屋类型
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_ZHFG)
public interface GrzfTjMapper {


    /**
     * 新增统计信息
     * @param grzfTj
     * @return
     */
    int insert(GrzfTj grzfTj);

    /**
     * 修改统计信息
     * @param grzfTj
     * @return
     */
    int update(GrzfTj grzfTj);


    /**
     * 根据开始套数和截止套数以及房屋用途查询是否存在统计信息
     * @param tsks
     * @param tsjz
     * @param yt  0全部用途   1住宅通途
     * @return
     */
    GrzfTj selectByTsQjAndYt(@Param("tsks") Integer tsks, @Param("tsjz") Integer tsjz, @Param("yt") Integer yt);



}




