package com.coob.sjts.modules.zhfg.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.zhfg.domain.GrzfTj;
import com.coob.sjts.modules.zhfg.domain.GrzfTjNl;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.transaction.annotation.Transactional;


/**
 * 个人住房统计  根据炼灵
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_ZHFG)
public interface GrzfTjNlMapper {


    /**
     * 新增统计信息
     * @param grzfTj
     * @return
     */
    int insert(GrzfTjNl grzfTj);

    /**
     * 修改统计信息
     * @param grzfTj
     * @return
     */
    int update(GrzfTjNl grzfTj);


    /**
     * 根据年龄阶段统计
     * @param ksnl
     * @param jznl
     * @return
     */
    GrzfTjNl selectByNl(@Param("ksnl") Integer ksnl, @Param("jznl") Integer jznl);



}




