package com.coob.sjts.modules.zhfg.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.zhfg.domain.GrzfTj;
import com.coob.sjts.modules.zhfg.domain.GrzfTjQy;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.transaction.annotation.Transactional;


/**
 * 个人住房统计  根据区域
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_ZHFG)
public interface GrzfTjQyMapper {


    /**
     * 新增统计信息
     * @param grzfTj
     * @return
     */
    int insert(GrzfTjQy grzfTj);

    /**
     * 修改统计信息
     * @param grzfTj
     * @return
     */
    int update(GrzfTjQy grzfTj);


    /**
     * 根据区域统计
     * @param qy 1 寿光  2潍坊  3山东  4其他
     * @return
     */
    GrzfTjQy selectByQy(@Param("qy") Integer qy);



}




