package com.coob.sjts.modules.zhfg.mapper;

import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.zhfg.domain.wk.SgYskyj;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * (SgYskyj)表数据库访问层
 *
 * @author makejava
 * @since 2023-11-22 09:14:37
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_ZHFG)
public interface WkSgYskyjMapper {

    /**
     * 统计首付款1个月没交存的合同数量
     * @return
     */
    List<SgYskyj> selectCountSfkYj1();

    /**
     * 统计首付款2个月没交存的合同数量
     * @return
     */
    List<SgYskyj> selectCountSfkYj2();

    /**
     * 统计商业贷款5个月没交存的合同数量
     * @return
     */
    List<SgYskyj> selectCountSydkYj1();

    /**
     * 统计商业贷款6个月没交存的合同数量
     * @return
     */
    List<SgYskyj> selectCountSydkYj2();

    /**
     * 统计公积金贷款4个月没交存的合同数量
     * @return
     */
    List<SgYskyj> selectCountGjjYj1();

    /**
     * 统计公积金贷款5个月没交存的合同数量
     * @return
     */
    List<SgYskyj> selectCountGjjYj2();


    List<SgYskyj> selectHtQy();

}

