package com.coob.sjts.modules.zhfg.mapper;


import com.coob.sjts.datasource.constant.DBConstants;
import com.coob.sjts.modules.zhfg.domain.zjt.ZjtSpfTj;
import com.coob.sjts.modules.zhfg.domain.zjt.ZjtSpfXiaoshouTj;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * (ZjtSpfXiaoshouTj)表数据库访问层
 *
 * @author makejava
 * @since 2024-06-12 09:49:07
 */
@Mapper
@Transactional(transactionManager = DBConstants.TX_MANAGER_ZHFG)
public interface ZjtSpfXiaoshouTjMapper {


    /**
     * 插入月报信息
     * @param zjtSpfXiaoshouTj
     * @return
     */
    int insert(ZjtSpfXiaoshouTj zjtSpfXiaoshouTj);


    /**
     * 修改月报信息
     * @param zjtSpfXiaoshouTj
     * @return
     */
    int update(ZjtSpfXiaoshouTj zjtSpfXiaoshouTj);


    /**
     * 根据年度和月度修改月报信息
     * @param zjtSpfXiaoshouTj
     * @return
     */
    int updateByNy(ZjtSpfXiaoshouTj zjtSpfXiaoshouTj);


    /**
     * 统计年度所有月报数据
     * @param nd
     * @return
     */
    ZjtSpfXiaoshouTj countYbByNd(int nd);

    /**
     * 查询指定年月的月报信息
     * @param nd
     * @param yd
     * @return
     */
    ZjtSpfXiaoshouTj selectXsybByNdAndYd(@Param("nd") int nd, @Param("yd") int yd);


    /**
     * 获取最近12个月的月报数据  不包含本月
     * @param len
     * @return
     */
    List<ZjtSpfXiaoshouTj> selectYbBylen();


}

