package com.coob.sjts.modules.zhfg.service;


import com.coob.sjts.modules.zhfg.domain.GrzfTj;
import com.coob.sjts.modules.zhfg.domain.GrzfTjMj;
import com.coob.sjts.modules.zhfg.domain.GrzfTjNl;
import com.coob.sjts.modules.zhfg.domain.GrzfTjQy;
import com.coob.sjts.modules.zhfg.mapper.GrzfTjMapper;
import com.coob.sjts.modules.zhfg.mapper.GrzfTjMjMapper;
import com.coob.sjts.modules.zhfg.mapper.GrzfTjNlMapper;
import com.coob.sjts.modules.zhfg.mapper.GrzfTjQyMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class GrzfTjService {

    @Resource
    private GrzfTjMapper grzfTjMapper;
    @Resource
    private GrzfTjNlMapper nlMapper;
    @Resource
    private GrzfTjQyMapper qyMapper;
    @Resource
    private GrzfTjMjMapper grzfTjMjMapper;


    /**************************************************************************/
                                /*按用房屋途统计购房数据*/
    /*************************************************************************/
    /**
     * 新增按用途统计个人住房数据
     * @param grzfTj
     * @return
     */
    public int insert(GrzfTj grzfTj) {
        return grzfTjMapper.insert(grzfTj);
    }

    /**
     * 修改按用途统计个人住房数据
     * @param grzfTj
     * @return
     */
    public int update(GrzfTj grzfTj) {
        return grzfTjMapper.update(grzfTj);
    }

    /**
     * 按用途和套数区间查询统计数据
      * @param tsks
     * @param tsjz
     * @param yt
     * @return
     */
    public GrzfTj selectByTsQjAndYt(Integer tsks, Integer tsjz, Integer yt) {
        return grzfTjMapper.selectByTsQjAndYt(tsks,tsjz,yt);
    }

    /****************************************************************************************/
                                /*按年龄统计购房数据*/
    /****************************************************************************************/

    public int insertNl(GrzfTjNl grzfTjNl){
        return nlMapper.insert(grzfTjNl);
    }

    public int updateNl(GrzfTjNl grzfTjNl){
        return nlMapper.update(grzfTjNl);
    }

    public GrzfTjNl selectByNl(Integer ksnl, Integer jznl){
        return nlMapper.selectByNl(ksnl,jznl);
    }

    /****************************************************************************************/
                                /*按区域统计购房数据*/
    /****************************************************************************************/

    public int insertQy(GrzfTjQy grzfTjQy){
        return qyMapper.insert(grzfTjQy);
    }

    public int updateQy(GrzfTjQy grzfTjQy){
        return qyMapper.update(grzfTjQy);
    }

    public GrzfTjQy selectByQy(Integer qy){
        return qyMapper.selectByQy(qy);
    }

    public int insertOrUpdateBatch(List<GrzfTjMj> list){
        return grzfTjMjMapper.insertOrUpdateBatch(list);
    }



}
