package com.coob.sjts.modules.zhfg.service.zjt;


import com.coob.sjts.common.tool.DateUtil;
import com.coob.sjts.modules.mis.mapper.ZjtSpfXsTjMapper;
import com.coob.sjts.modules.zhfg.domain.zjt.ZjtSpfTj;
import com.coob.sjts.modules.zhfg.domain.zjt.ZjtSpfXiaoshouTj;
import com.coob.sjts.modules.zhfg.mapper.ZjtSpfTjMapper;
import com.coob.sjts.modules.zhfg.mapper.ZjtSpfXiaoshouTjMapper;
import com.github.pagehelper.Page;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.List;

/**
 * 商品房统计(ZjtSpfTj)表服务实现类
 *
 * @author makejava
 * @since 2024-06-12 09:49:43
 */
@Service
public class ZjtSpfTjService{
    @Resource
    private ZjtSpfTjMapper zjtSpfTjMapper;
    @Resource
    private ZjtSpfXiaoshouTjMapper zjpTjMapper;
    @Resource
    private ZjtSpfXsTjMapper tjMapper;



    public void  saveTj(){
        int beforeMonth = DateUtil.getBeforeMonth();
        String sy = DateUtil.getCompleteMonth(beforeMonth);
        ZjtSpfTj tj = tjMapper.countFwtj();

        //查询最近12个月的月报数据  不包含本月
        List<ZjtSpfXiaoshouTj> xiaoshouTjs = zjpTjMapper.selectYbBylen();
        BigDecimal xsmj = BigDecimal.ZERO;
        BigDecimal xsmjZ = BigDecimal.ZERO;

        int yd = DateUtil.getCurMonth();
        String by = DateUtil.getCompleteMonth(yd);
        int yf = 0;
        for( ZjtSpfXiaoshouTj yb: xiaoshouTjs ){
            if( !yb.getYd().equals(by) ) {
                xsmj = xsmj.add(yb.getXsmj());
                xsmjZ = xsmjZ.add(yb.getXszzmj());
                yf ++;
            }
            if(yb.getYd().equals(sy)){
                tj.setKcts(yb.getKcts());
                tj.setKcmj(yb.getKcmj());
                tj.setKcmjz(yb.getKczzmj());
                tj.setKctsz(yb.getKczzts());
            }
        }

        //月平均销量
        BigDecimal byf = new BigDecimal(""+yf);
        BigDecimal yxsmj = xsmj.divide(byf, 2, BigDecimal.ROUND_HALF_UP);
        BigDecimal yxsmjz = xsmjZ.divide(byf, 2, BigDecimal.ROUND_HALF_UP);

        //去化周期
        BigDecimal qhzq = tj.getKcmj().divide(yxsmj, 0, BigDecimal.ROUND_HALF_UP);
        BigDecimal qhzqz = tj.getKcmjz().divide(yxsmjz, 0, BigDecimal.ROUND_HALF_UP);
        tj.setYxsmj(yxsmj);
        tj.setYxsmjz(yxsmjz);
        tj.setQhzq(qhzq.intValue());
        tj.setQhzqz(qhzqz.intValue());

        //统计农房村数量
        int nfcsl = tjMapper.countNfc();
        tj.setCsnf(nfcsl);

        //统计农房信息
        ZjtSpfTj _nf = tjMapper.countNcfxx();
        Integer ztsnf = _nf.getZtsnf();
        BigDecimal zmjnf = _nf.getZmjnf();

        tj.setZtsnf(ztsnf);
        tj.setZmjnf(zmjnf);


        zjtSpfTjMapper.update(tj);



    }



}
