package com.coob.sjts.modules.zhfg.service.zjt;


import com.coob.sjts.common.tool.DateUtil;
import com.coob.sjts.modules.mis.mapper.ZjtSpfXsTjMapper;
import com.coob.sjts.modules.zhfg.domain.zjt.ZjtSpfXiaoshouTj;
import com.coob.sjts.modules.zhfg.mapper.ZjtSpfXiaoshouTjMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;

/**
 * (ZjtSpfXiaoshouTj)表服务实现类
 *
 * @author makejava
 * @since 2024-06-12 09:49:13
 */
@Service
public class ZjtSpfXiaoshouTjService {
    @Resource
    private ZjtSpfXiaoshouTjMapper zjtSpfXiaoshouTjMapper;

    @Resource
    private ZjtSpfXsTjMapper tjMapper;


    /**
     * 保存年报数据
     * @return
     */
    public void saveNb(){
        int nd = DateUtil.getCurYear();
        //查询是否有本年度数据
        ZjtSpfXiaoshouTj xsnb = zjtSpfXiaoshouTjMapper.selectXsybByNdAndYd(nd, 0);
        if(xsnb == null){
            //如果没有本年度数据则新增
            zjtSpfXiaoshouTjMapper.insert(new ZjtSpfXiaoshouTj().createXiaoshouTj(0));
        }

        //统计本年的所有月报信息
        ZjtSpfXiaoshouTj nb = zjtSpfXiaoshouTjMapper.countYbByNd(nd);
        if(nb != null){
            //计算销售住宅均价
            BigDecimal jj = nb.getXszzje().divide(nb.getXszzmj(), 2, BigDecimal.ROUND_HALF_UP);
            nb.setXszzjj(jj);
            zjtSpfXiaoshouTjMapper.updateByNy(nb);
        }
    }

    /**
     * 保存月报数据
     * @return
     */
    public int saveYb(){

        //获取当前月份
        int by = DateUtil.getCurMonth();
        //获取上月个月
        int sy = DateUtil.getBeforeMonth();
        //获取上一年
        int nd = 0 ;
        if(by == 1){
            //获取上一年
            nd = DateUtil.getBeforeYear();
        }else{
            //获取本年
            nd = DateUtil.getCurYear();
        }

        //查询本年本月的月报
        ZjtSpfXiaoshouTj tj = zjtSpfXiaoshouTjMapper.selectXsybByNdAndYd(nd, by);
        //查询上一个月度的月报
        ZjtSpfXiaoshouTj lsyb = zjtSpfXiaoshouTjMapper.selectXsybByNdAndYd(nd, sy);
        if(tj == null){
            ZjtSpfXiaoshouTj xiaoshouTj = new ZjtSpfXiaoshouTj().createXiaoshouTj(1);
            // 赋值库存等信息
            xiaoshouTj.setInitYdKc(lsyb);
            zjtSpfXiaoshouTjMapper.insert(xiaoshouTj);
            tj = zjtSpfXiaoshouTjMapper.selectXsybByNdAndYd(nd, by);
        }
        // 获取本月信息
        ZjtSpfXiaoshouTj zjtSpfXiaoshouTj = tjMapper.selectByXsyb();
        if(zjtSpfXiaoshouTj == null){
            // 本月信息 统计为空 则不需要更新数据
            return 1;
        }
        // 本月销售数据更新
        tj.setByydxs(zjtSpfXiaoshouTj);

        //计算销售住宅均价
        BigDecimal zzjj = tj.getXszzje().divide(tj.getXszzmj(), 2, BigDecimal.ROUND_HALF_UP);
        tj.setXszzjj(zzjj);
        //计算库存面积  这个月的批售面积-这个月的销售面积+上个月的库存面积
        BigDecimal kcmj = tj.getPsmj().subtract(tj.getXsmj()).add(lsyb.getKcmj());
        tj.setKcmj(kcmj);
        //计算库存住宅套数   这个月的批售住宅套数-这个月的销售住宅套数 +上个月的库存住宅套数
        Integer kczzts = tj.getPszzts()-tj.getXszzts()+lsyb.getKczzts();
        tj.setKczzts(kczzts);
        //计算库存住宅面积  这个月的批售住宅面积-这个月的销售住宅面积+上个月的库存住宅面积
        BigDecimal kczzmj = tj.getPszzmj().subtract(tj.getXszzmj()).add(lsyb.getKczzmj());
        tj.setKczzmj(kczzmj);

        tj.setTssj(DateUtil.getCurDate());

        zjtSpfXiaoshouTjMapper.updateByNy(tj);

        return 1;
    }

    /**
     * 修改月报表数据
     * @param xsyb
     * @return
     */
    public int update(ZjtSpfXiaoshouTj xsyb){
        return zjtSpfXiaoshouTjMapper.update(xsyb);
    }




}
